unit Graf;

{Grf komponens - Ksztette: Benk Tams - Mdostva: 1997.04.29.}

interface

uses
 SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
 StdCtrls, ExtCtrls, Dialogs, Forms, Buttons, Clipbrd, Mask, Spin;

const
 SBSzel=15;          {A ScrollBar szlessge}
 ScrollKisValt=10;   {A ScrollBar SmallChange jellemzjnek rtke}
 KeretSzel=1;        {A komponenst vez keret szlessge}
 ISavMag=24;         {Az infsv magassga}
 IPoz2=130;          {Az infsv 2. rsznek pozcija}
 IPoz3=230;          {Az infsv 3. rsznek pozcija}
 USavMag=24;         {Az zenetsv magassga}
 NyilSzog=0.25;      {A nyl cscsszge radinban}
 GombDb=15;          {Nyomgombok szma, rajzai, feliratai}
 GombRajzok: array[1..GombDb] of string = ('UJGRAF.BMP','BETOLT.BMP',
             'KIMENT.BMP','NEVADAS.BMP','CLIPBMAS.BMP','UJPONT.BMP','PONTMOD.BMP',
             'PONTTORL.BMP','UJEL.BMP','ELTORL.BMP','PONTJEL.BMP','ELJEL.BMP',
             'NAGYIT.BMP','KICSINY.BMP','EGY_EGY.BMP');
 GombFeliratok: array[1..GombDb] of string = ('j grf','Betlt','Kiment',
                'Grfnv','Msols a vglapra','j pont','Ponthely mdosts',
                'Pont trls','j l','l trls','Pont kijekls','l kijells','Nagyt',
                'Kicsinyt','Alaphelyzet');
 KoordMin=-1000000;  {A pont koordintk minimum rtke}
 KoordMax= 1000000;  {A pont koordintk maximum rtke}

type
 RPont= record
  x,y,sx,sy: Longint;
  azon: Word;
  jel: Boolean;
 end;

 REl= record
  p1,p2: Word;
  h: Longint;
  jel: Boolean;
 end;

 TGrafNev= string[20];

{A grf adatait trol objektumok tpusdeklarcija}

 TPont= class(TObject)
 private
  Fx,Fy,Fsx,Fsy: Longint;
  Fazon: Word;
  Fjel: Boolean;
 public
  constructor Create(az: Word; x1,y1,x2,y2: Longint; j: Boolean);
  property x: Longint read Fx write Fx;
  property y: Longint read Fy write Fy;
  property sx: Longint read Fsx write Fsx;
  property sy: Longint read Fsy write Fsy;
  property azon: Word read Fazon write Fazon;
  property jel: Boolean read Fjel write Fjel;
 end;

 TEl= class(TObject)
 private
  Fp1,Fp2: Word;
  Fh: Longint;
  Fjel: Boolean;
 public
  constructor Create(hossz: Longint; honnan,hova: Word; j: Boolean);
  property p1: Word read Fp1 write Fp1;
  property p2: Word read Fp2 write Fp2;
  property h: Longint read Fh write Fh;
  property jel: Boolean read Fjel write Fjel;
 end;

 TGraf = class(TCustomPanel)
 private
  FPontSugar: Integer;
  FNyilHossz: Byte;
  FNagyitas: Word;
  FGrafFajl: string;
  FVanELAdat: Boolean;
  FVanPont: Boolean;
  FVanPontAzon: Boolean;
  FVanNyil: Boolean;
  FVanEl: Boolean;
  FSzinPont, FSzinEl, FSzinKepernyo: TColor;
  FSzinJelPont, FSzinJelEl: TColor;
  FCimkeFont: TFont;
  FVanToolBar: Boolean;
  FElHosszAlap: Longint;

  FPDb: Integer;
  FEDb: Integer;
  FAranyHor,FAranyVer: Real;
  FElozoNagyitas: Word;
  FMaxX,FMaxY,FMinX,FMinY: Longint;
  FLatX,FLatY: Longint;
  FKepMag,FKepSzel: Longint;
  FVanAdat: Boolean;
  FValtozas: Boolean;
  FMentSzuks: Boolean;
  FTBMag: Integer;
  FModPontIndex: Integer;
  FPontLista,FElLista: TStringList;
  FHorScroll,FVerScroll: TScrollBar;
  FRajzVaszon: TImage;
  FSpinner: TSpinEdit;
  FPontAzonMezo, FElHosszMezo: TMaskEdit;
  FGrafNev: TGrafNev;
  FGrafNevMezo: TEdit;
  FSegedPont: RPont;
  FSegedEl: REl;
  FGombok: array[1..GombDb] of TSpeedButton;

  procedure SetNagyitas(Value: Word);
  procedure SetGrafFajl(Value: string);
  procedure SetPontSugar(Value: Integer);
  procedure SetNyilHossz(Value: Byte);
  procedure SetVanElAdat(Value: Boolean);
  procedure SetVanPont(Value: Boolean);
  procedure SetVanPontAzon(Value: Boolean);
  procedure SetVanNyil(Value: Boolean);
  procedure SetVanEl(Value: Boolean);
  procedure SetSzinEl(Value: TColor);
  procedure SetSzinJelPont(Value: TColor);
  procedure SetSzinJelEl(Value: TColor);
  procedure SetSzinPont(Value: TColor);
  procedure SetSzinKepernyo(Value: TColor);
  procedure SetCimkeFont(Value: TFont);
  procedure SetVanToolBar(Value: Boolean);
  procedure SetGrafNev(Value: TGrafNev);
  procedure SetElHosszAlap(Value: Longint);

 protected
  procedure HorScrollProc(Sender: TObject; ScrollCode: TScrollCode; var ScrollPos: Integer);
  procedure VerScrollProc(Sender: TObject; ScrollCode: TScrollCode; var ScrollPos: Integer);
  procedure MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  procedure MouseDownUjPont(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  procedure MouseDownPontHelyMod1(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  procedure MouseDownPontHelyMod2(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  procedure MouseDownTorlPont(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  procedure MouseDownPontKijelol(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  procedure MouseDownUjEl1(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  procedure MouseDownUjEl2(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  procedure MouseDownElKijelol1(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  procedure MouseDownElKijelol2(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  procedure MouseDownTorlEl1(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  procedure MouseDownTorlEl2(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  procedure MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
  procedure MouseMoveInfo(Sender: TObject; Shift: TShiftState; X, Y: Integer);
  procedure Betoltes_Click(Sender: TObject);
  procedure Kimentes_Click(Sender: TObject);
  procedure Nagyit_Click(Sender: TObject);
  procedure Kicsinyit_Click(Sender: TObject);
  procedure Alaphelyzet_Click(Sender: TObject);
  procedure UjGraf_Click(Sender: TObject);
  procedure UjPont_Click(Sender: TObject);
  procedure PontHelyMod_Click(Sender: TObject);
  procedure PontTarolas(Sender: TObject);
  procedure Exit(Sender: TObject);
  procedure EscKeyPress(Sender: TObject; var Key: Char);
  procedure PontTorol_Click(Sender: TObject);
  procedure UjEl_Click(Sender: TObject);
  procedure ElTarolas(Sender: TObject);
  procedure ElTorol_Click(Sender: TObject);
  procedure PontKijelol_Click(Sender: TObject);
  procedure ElKijelol_Click(Sender: TObject);
  procedure ClipboardraMasol_Click(Sender: TObject);
  procedure PontSugarValtozas(Sender: TObject);
  procedure NevAdas_Click(Sender: TObject);
  procedure NevTarolas(Sender: TObject);

  procedure KoordinataSzamol;
  procedure NyilRajzolas(HonnanX,HonnanY,HovaX,HovaY: Integer);
  procedure Info1(const szoveg: string);
  procedure Info2(const szoveg: string);
  procedure Info3(const szoveg: string);
  procedure Uzenet(const szoveg: string);
  procedure GombokTilt;
  procedure GombokEnged;
  procedure NincsTobbMemoria;
  procedure HibasFajl;
  function JavasoltAzonosito: string;
  function JoAdat(var s: string): Boolean;
  function PontListaAzonKeszit(az: Integer): string;
  function ElListaAzonKeszit(p1,p2: Integer): string;

  procedure Rajzolas; virtual;
  procedure Paint; override;
  procedure MeretBeallitasok;
  procedure Resize; override;

  property PDb: Integer read FPDb write FPDb;
  property EDb: Integer read FEDb write FEDb;
  property AranyHor: Real read FAranyHor write FAranyHor;
  property AranyVer: Real read FAranyVer write FAranyVer;
  property ElozoNagyitas: Word read FElozoNagyitas write FElozoNagyitas;
  property MaxX: Longint read FMaxX write FMaxX;
  property MaxY: Longint read FMaxY write FMaxY;
  property MinX: Longint read FMinX write FMinX;
  property MinY: Longint read FMinY write FMinY;
  property LatX: Longint read FLatX write FLatX;
  property LatY: Longint read FLatY write FLatY;
  property KepMag: Longint read FKepMag write FKepMag;
  property KepSzel: Longint read FKepSzel write FKepSzel;
  property VanAdat: Boolean read FVanAdat write FVanAdat;
  property Valtozas: Boolean read FValtozas write FValtozas;
  property MentSzuks: Boolean read FMentSzuks write FMentSzuks;
  property TBMag: Integer read FTBMag write FTBMag;
  property PontLista: TStringList read FPontLista write FPontLista;
  property ElLista: TStringList read FElLista write FElLista;
  property HorScroll: TScrollBar read FHorScroll write FHorScroll;
  property VerScroll: TScrollBar read FVerScroll write FVerScroll;
  property RajzVaszon: TImage read FRajzVaszon write FRajzVaszon;
  property Spinner: TSpinEdit read FSpinner write FSpinner;
  property PontAzonMezo: TMaskEdit read FPontAzonMezo write FPontAzonMezo;
  property ElHosszMezo: TMaskEdit read FElHosszMezo write FElHosszMezo;
  property GrafNev: TGrafNev read FGrafNev write SetGrafNev;
  property GrafNevMezo: TEdit read FGrafNevMezo write FGrafNevMezo;
  property ModPontIndex: Integer read FModPontIndex write FModPontIndex;

 public
  constructor Create(AOwner: TComponent); override;
  destructor Destroy; override;
  procedure Betolt;
  procedure Kiment;
  procedure Nagyit;
  procedure Kicsinyit;
  procedure Alaphelyzet;
  procedure UjGraf;
  procedure UjPont;
  procedure PontHelyMod;
  procedure PontTorol;
  procedure UjEl;
  procedure ElTorol;
  procedure PontKijelol;
  procedure ElKijelol;
  procedure ClipboardraMasol;
  procedure NevAdas;
  function MentesKell: Boolean;

 published
  property Align default alClient;
  property Nagyitas: Word read FNagyitas write SetNagyitas default 100;
  property GrafFajl: string read FGrafFajl write SetGrafFajl;
  property PontSugar: Integer read FPontSugar write SetPontSugar default 9;
  property VanElAdat: Boolean read FVanElAdat write SetVanElAdat default True;
  property VanPont: Boolean read FVanPont write SetVanPont default True;
  property VanNyil: Boolean read FVanNyil write SetVanNyil default True;
  property NyilHossz: Byte read FNyilHossz write SetNyilHossz default 8;
  property VanEl: Boolean read FVanEl write SetVanEl default True;
  property SzinJelPont: TColor read FSzinJelPont write SetSzinJelPont default clAqua;
  property SzinJelEl: TColor read FSzinJelEl write SetSzinJelEl default clBlue;
  property SzinPont: TColor read FSzinPont write SetSzinPont default clSilver;
  property SzinEl: TColor read FSzinEl write SetSzinEl default clBlack;
  property SzinKepernyo: TColor read FSzinKepernyo write SetSzinKepernyo default clWhite;
  property CimkeFont: TFont read FCimkeFont write SetCimkeFont;
  property VanPontAzon: Boolean read FVanPontAzon write SetVanPontAzon default True;
  property VanToolBar: Boolean read FVanToolBar write SetVanToolBar default True;
  property ElHosszAlap: Longint read FElHosszAlap write SetElHosszAlap default 100;
end;

procedure Register;

implementation

procedure Register;
begin
 RegisterComponents('Samples', [TGraf]);
end;

constructor TGraf.Create(AOwner: TComponent);
var i: Integer;
    pozicio: Integer;
begin
 inherited Create(AOwner);
 Align:=alClient;
 TBMag:=30;
 MentSzuks:=False;
 FVanToolBar:=True;
 FPontSugar:=9;
 FElHosszAlap:=100;
 FNyilHossz:=8;
 FVanElAdat:=True;
 FVanPont:=True;
 FVanPontAzon:=True;
 FVanNyil:=True;
 FVanEl:=True;
 FSzinPont:=clSilver;
 FSzinEl:=clBlack;
 FSzinJelPont:=clAqua;
 FSzinJelEl:=clBlue;
 FSzinKepernyo:=clWhite;
 FCimkeFont:=TFont.Create;
 FCimkeFont.Name:='Arial';
 FCimkeFont.Size:=7;
 FCimkeFont.Style:=[];
 FNagyitas:=100;
 ElozoNagyitas:=100;
 KepSzel:=Width-SBSzel-2*KeretSzel-3;
 KepMag:=Height-ISavMag-SBSzel-2*KeretSzel-TBMag-USavMag-2;
 FGrafFajl:='';
 RajzVaszon:=TImage.Create(Self);
 RajzVaszon.Top:=ISavMag+KeretSzel+TBMag;
 RajzVaszon.Left:=KeretSzel+1;
 RajzVaszon.Width:=800;
 RajzVaszon.Height:=600;
 RajzVaszon.OnMouseMove:=MouseMoveInfo;
 InsertControl(RajzVaszon);
 RajzVaszon.Canvas.Pen.Color:=clBtnFace;
 RajzVaszon.Canvas.Brush.Color:=clBtnFace;
 RajzVaszon.Canvas.Rectangle(0,0,RajzVaszon.Width,RajzVaszon.Height);
 RajzVaszon.Width:=KepSzel;
 RajzVaszon.Height:=KepMag;
 HorScroll:= TScrollBar.Create(Self);
 HorScroll.Kind:=sbHorizontal;
 HorScroll.Top:=Height-KeretSzel-USavMag-SBSzel-1;
 HorScroll.Left:=RajzVaszon.Left+2;
 HorScroll.Width:=KepSzel;
 HorScroll.Height:=SBSzel;
 HorScroll.OnScroll:=HorScrollProc;
 VerScroll:=TScrollBar.Create(Self);
 VerScroll.Kind:= sbVertical;
 VerScroll.Top:=RajzVaszon.Top;
 VerScroll.Left:=Width-SBSzel-KeretSzel-1;
 VerScroll.Height:=KepMag;
 VerScroll.Width:=SBSzel;
 VerScroll.OnScroll:=VerScrollProc;
 InsertControl(HorScroll);
 InsertControl(VerScroll);
 HorScroll.LargeChange:=Round(KepSzel/2);
 VerScroll.LargeChange:=Round(KepMag/2);
 HorScroll.SmallChange:=ScrollKisValt;
 VerScroll.SmallChange:=ScrollKisValt;
 pozicio:=0;
 for i:=1 to GombDb do begin
  FGombok[i]:=TSpeedButton.Create(Self);
  FGombok[i].Top:=KeretSzel;
  case i of
    5: pozicio:=10;
    6: pozicio:=20;
    11: pozicio:=30;
    13: pozicio:=40;
  end;
  FGombok[i].Left:=KeretSzel+(i-1)*28+pozicio;
  FGombok[i].Glyph.LoadFromFile(GombRajzok[i]);
  FGombok[i].ShowHint:=True;
  FGombok[i].Hint:=GombFeliratok[i];
  InsertControl(FGombok[i]);
  if i>2 then begin
   FGombok[i].Enabled:=False;
   FGombok[i].ShowHint:=False;
  end;
 end;
 FGombok[1].OnClick:=UjGraf_Click;
 FGombok[2].OnClick:=Betoltes_Click;
 FGombok[3].OnClick:=Kimentes_Click;
 FGombok[4].OnClick:=NevAdas_Click;
 FGombok[5].OnClick:=ClipboardraMasol_Click;
 FGombok[6].OnClick:=UjPont_Click;
 FGombok[7].OnClick:=PontHelyMod_Click;
 FGombok[8].OnClick:=PontTorol_Click;
 FGombok[9].OnClick:=UjEl_Click;
 FGombok[10].OnClick:=ElTorol_Click;
 FGombok[11].OnClick:=PontKijelol_Click;
 FGombok[12].OnClick:=ElKijelol_Click;
 FGombok[13].OnClick:=Nagyit_Click;
 FGombok[14].OnClick:=Kicsinyit_Click;
 FGombok[15].OnClick:=Alaphelyzet_Click;
 PontAzonMezo:=TMaskEdit.Create(Self);
 PontAzonMezo.Font.Name:='Arial';
 PontAzonMezo.Font.Size:=8;
 PontAzonMezo.Font.Style:=[];
 PontAzonMezo.Top:=KeretSzel+TBMag+3;
 PontAzonMezo.Left:=KeretSzel+IPoz3+5;
 PontAzonMezo.Height:=18;
 PontAzonMezo.Width:=37;
 Mask.DefaultBlank := ' ';
 PontAzonMezo.EditMask := '99999';
 PontAzonMezo.Hide;
 InsertControl(PontAzonMezo);
 ElHosszMezo:=TMaskEdit.Create(Self);
 ElHosszMezo.Font.Name:='Arial';
 ElHosszMezo.Font.Size:=8;
 ElHosszMezo.Font.Style:=[];
 ElHosszMezo.Top:=KeretSzel+TBMag+3;
 ElHosszMezo.Left:=KeretSzel+IPoz3+5;
 ElHosszMezo.Height:=18;
 ElHosszMezo.Width:=42;
 ElHosszMezo.EditMask := '999999';
 ElHosszMezo.Hide;
 InsertControl(ElHosszMezo);
 Spinner:=TSpinEdit.Create(Self);
 Spinner.Font.Name:='Arial';
 Spinner.Font.Size:=8;
 Spinner.Font.Style:=[];
 Spinner.Top:=KeretSzel+1;
 Spinner.Left:=FGombok[GombDb].Left+40;
 Spinner.Height:=15;
 Spinner.Width:=37;
 Spinner.MaxLength:=2;
 Spinner.MaxValue:=20;
 Spinner.MinValue:=1;
 Spinner.Value:=PontSugar;
 Spinner.OnChange:=PontSugarValtozas;
 InsertControl(Spinner);
 Spinner.Enabled:=False;
 GrafNevMezo:=TEdit.Create(Self);
 GrafNevMezo.Font.Name:='Arial';
 GrafNevMezo.Font.Size:=8;
 GrafNevMezo.Font.Style:=[];
 GrafNevMezo.Top:=KeretSzel+TBMag+3;
 GrafNevMezo.Left:=KeretSzel+5;
 GrafNevMezo.Height:=18;
 GrafNevMezo.Width:=120;
 GrafNevMezo.MaxLength:=20;
 GrafNevMezo.Hide;
 InsertControl(GrafNevMezo);
 PontLista:=TStringList.Create;
 PontLista.Sorted:=True;
 ElLista:=TStringList.Create;
 ElLista.Sorted:=True;
 MentSzuks:=False;
 Valtozas:=True;
end;

destructor TGraf.Destroy;
var i: Integer;
begin
 ElLista.Free;
 PontLista.Free;
 GrafNevMezo.Free;
 Spinner.Free;
 ElHosszMezo.Free;
 PontAzonMezo.Free;
 for i:=1 to GombDb do FGombok[i].Free;
 VerScroll.Free;
 HorScroll.Free;
 RajzVaszon.Free;
 FCimkeFont.Free;
 inherited Destroy;
end;

{Pontazonosit ksztse a Pont listhoz}

function TGraf.PontListaAzonKeszit(az: Integer): string;
var s: string;
begin
 s:=IntToStr(az);
 while Length(s)<5 do s:='0'+s;
 Result:=s;
end;

{lazonosit ksztse az l listhoz}

function TGraf.ElListaAzonKeszit(p1,p2: Integer): string;
var s: string;
begin
 s:=IntToStr(p2);
 while Length(s)<5 do s:='0'+s;
 s:=IntToStr(p1)+s;
 while Length(s)<10 do s:='0'+s;
 Result:=s;
end;

{j grf felvtele}

procedure TGraf.UjGraf;
begin
 if MentSzuks then
  if MessageDlg('A trban lv grf kitrlhet ?',
   mtInformation,[mbYes, mbNo],0)=mrYes then
   MentSzuks:=False;
 if not(MentSzuks) then begin
  PontLista.Clear;
  ElLista.Clear;
  PDb:=0;
  EDb:=0;
  with RajzVaszon.Canvas do begin
   Pen.Color:=clWhite;
   Brush.Color:=clWhite;
   Rectangle(0,0,Width,Height);
  end;
  MinX:=0;
  MinY:=0;
  MaxX:=RajzVaszon.Width;
  MaxY:=RajzVaszon.Height;
  KepSzel:=RajzVaszon.Width;
  KepMag:=RajzVaszon.Height;
  LatX:=0;
  LatY:=0;
  AranyHor:=1;
  AranyVer:=1;
  VanAdat:=True;
  Valtozas:=True;
  GombokEnged;
  Nagyitas:=100;
  ElozoNagyitas:=100;
  GrafNev:='';
 end;
end;

procedure TGraf.UjGraf_Click(Sender: TObject);
begin
 UjGraf;
end;

{A megjelentett pont s l koordintk szmolsa}

procedure TGraf.KoordinataSzamol;
var i: Integer;
    segedx,segedy: Longint;
begin
 segedx:=Round(LatX+RajzVaszon.Width/2);
 segedy:=Round(LatY+RajzVaszon.Height/2);
 AranyHor:=(RajzVaszon.Width/KepSzel)*(Nagyitas/100);
 AranyVer:=(RajzVaszon.Height/KepMag)*(Nagyitas/100);
 segedx:=Round(segedx*(Nagyitas/ElozoNagyitas));
 segedy:=Round(segedy*(Nagyitas/ElozoNagyitas));
 LatX:=Round(segedx-RajzVaszon.Width/2);
 LatY:=Round(segedy-RajzVaszon.Height/2);
 if LatX<0 then LatX:=0;
 if LatY<0 then LatY:=0;
 if LatX>Round(KepSzel*AranyHor)-RajzVaszon.Width then LatX:=Round(KepSzel*AranyHor)-RajzVaszon.Width;
 if LatY>Round(KepMag*AranyVer)-RajzVaszon.Height then LatY:=Round(KepMag*AranyVer)-RajzVaszon.Height;
 HorScroll.Max:=Round(KepSzel*AranyHor)-RajzVaszon.Width;
 VerScroll.Max:=Round(KepMag*AranyVer)-RajzVaszon.Height;
 HorScroll.Position:=LatX;
 VerScroll.Position:=LatY;
 for i:=0 to PDb-1 do begin
  TPont(PontLista.Objects[i]).sx:=Round((TPont(PontLista.Objects[i]).x-MinX)*AranyHor);
  TPont(PontLista.Objects[i]).sy:=Round((MaxY-TPont(PontLista.Objects[i]).y)*AranyVer);
 end;
end;

{Grf adatainak betltse fjlbl}

procedure TGraf.Betolt;
var FajlMegnyitDialog: TOpenDialog;
begin
 if MentSzuks then
  if MessageDlg('Az aktulis grf kitrlhet ?',mtInformation,[mbYes,mbNo],0)=mrYes then MentSzuks:=False;
 if not(MentSzuks) then begin
  FajlMegnyitDialog:=TOpenDialog.Create(Self);
  FajlMegnyitDialog.Title:='Grf fjl betltse';
  FajlMegnyitDialog.Filter:='Jellt grf fjlok (*.gj)|*.gj|Grf fjlok (*.g)|*.g|Minden fjl (*.*)|*.*';
  if FajlMegnyitDialog.Execute then GrafFajl:=FajlMegnyitDialog.FileName;
  FajlMegnyitDialog.Free;
 end;
end;

procedure TGraf.Betoltes_Click(Sender: TObject);
begin
 Betolt;
end;

{Grf adatainak kimentse fjlba}

procedure TGraf.Kiment;
var sor,s: string;
    i: Integer;
    Jelzett: Boolean;
    FileAzon: TextFile;
    FajlMentDialog: TSaveDialog;
begin
 FajlMentDialog:=TSaveDialog.Create(Self);
 FajlMentDialog.Title:='Grf fjl elmentse';
 FajlMentDialog.Filter:='Jelzett grf fjlok (*.gj)|*.gj|Grf fjlok (*.g)|*.g|Minden fjl (*.*)|*.*';
 FajlMentDialog.FileName:=GrafFajl;
 if FajlMentDialog.Execute then begin
  FGrafFajl:=FajlMentDialog.FileName;
  if (FileExists(GrafFajl) and
   (MessageDlg('A fjl mr ltezik.  Fellrhat?',mtInformation,[mbYes,mbNo],0)=mrYes)) or
   (not(FileExists(GrafFajl)) and (GrafFajl<>'')) then begin
    AssignFile(FileAzon,GrafFajl);
    Rewrite(FileAzon);
    s:=GrafFajl;
    while s[1]<>'.' do s:=Copy(s,2,Length(s)-1);
    if s='.GJ' then Jelzett:=True else Jelzett:=False;
    if Jelzett then WriteLn(FileAzon,GrafNev);
    Writeln(FileAzon,IntToStr(PDb));
    for i:=0 to PDb-1 do begin
     str(TPont(PontLista.Objects[i]).azon:6,s); sor:=s;
     str(TPont(PontLista.Objects[i]).x:10,s); sor:=sor+s;
     str(TPont(PontLista.Objects[i]).y:10,s); sor:=sor+s;
     if Jelzett then
      if TPont(PontLista.Objects[i]).jel then sor:=sor+' 1'
      else sor:=sor+' 0';
     WriteLn(FileAzon,sor);
    end;
    Writeln(FileAzon,IntToStr(EDb));
    for i:=0 to EDb-1 do begin
     str(TEl(ElLista.Objects[i]).p1:6,s); sor:=s;
     str(TEl(ElLista.Objects[i]).p2:6,s); sor:=sor+s;
     str(TEl(ElLista.Objects[i]).h:7,s); sor:=sor+s;
     if Jelzett then
      if TEl(ElLista.Objects[i]).jel then sor:=sor+' 1'
      else sor:=sor+' 0';
     WriteLn(FileAzon,sor);
    end;
    WriteLn(FileAzon,'');
    CloseFile(FileAzon);
    MentSzuks:=False;
  end;
 end;
 FajlMentDialog.Free;
end;

procedure TGraf.Kimentes_Click(Sender: TObject);
begin
 Kiment;
end;

{A komponens mretezsnl szksges beltsok}

procedure TGraf.MeretBeallitasok;
begin
 RajzVaszon.Height:=Height-ISavMag-SBSzel-2*KeretSzel-TBMag-USavMag-2;
 RajzVaszon.Width:=Width-SBSzel-2*KeretSzel-3;
 RajzVaszon.Top:=ISavMag+KeretSzel+TBMag;
 HorScroll.Top:=Height-SBSzel-KeretSzel-USavMag-1;
 HorScroll.Width:=RajzVaszon.Width;
 VerScroll.Top:=RajzVaszon.Top;
 VerScroll.Left:=Width-SBSzel-KeretSzel-1;
 VerScroll.Height:=RajzVaszon.Height;
 HorScroll.LargeChange:=Round(RajzVaszon.Width/2);
 VerScroll.LargeChange:=Round(RajzVaszon.Height/2);
 PontAzonMezo.Top:=KeretSzel+TBMag+3;
 ElHosszMezo.Top:=KeretSzel+TBMag+3;
 GrafNevMezo.Top:=KeretSzel+TBMag+3;
end;

procedure TGraf.Resize;
begin
 inherited Resize;
 MeretBeallitasok;
 KoordinataSzamol;
 Valtozas:=True;
 Paint;
end;

{Grf kirajzolsa}

procedure TGraf.Rajzolas;
var i,j1,j2: Integer;
    szx,szy: Longint;
    s: string;
begin
 with Canvas do begin
  Pen.Color:=clBlack;
  Brush.Color:=clRed;
  Ellipse(KeretSzel+5,Height-KeretSzel-USavMag+4,KeretSzel+18,Height-KeretSzel-USavMag+17);
 end;
 with RajzVaszon.Canvas do begin
  Pen.Color:=SzinKepernyo;
  Brush.Color:=SzinKepernyo;
  Rectangle(0,0,Width,Height);
  if VanAdat then begin
   if VanEl then
    for i:=0 to EDb-1 do begin
     if TEl(ElLista.Objects[i]).jel then begin
      Pen.Color:=SzinJelEl;
      Brush.Color:=SzinJelEl;
     end
     else begin
      Pen.Color:=SzinEl;
      Brush.Color:=SzinEl;
     end;
     j1:=PontLista.IndexOf(PontListaAzonKeszit(TEl(ElLista.Objects[i]).p1));
     j2:=PontLista.IndexOf(PontListaAzonKeszit(TEl(ElLista.Objects[i]).p2));
     MoveTo(TPont(PontLista.Objects[j1]).sx-LatX,TPont(PontLista.Objects[j1]).sy-LatY);
     LineTo(TPont(PontLista.Objects[j2]).sx-LatX,TPont(PontLista.Objects[j2]).sy-LatY);
     if VanNyil then
      NyilRajzolas(TPont(PontLista.Objects[j1]).sx-LatX,TPont(PontLista.Objects[j1]).sy-LatY,
       TPont(PontLista.Objects[j2]).sx-LatX,TPont(PontLista.Objects[j2]).sy-LatY);
     if VanElAdat then begin
      Brush.Color:=SzinKepernyo;
      Font:=CimkeFont;
      if TEl(ElLista.Objects[i]).jel then Font.Color:=SzinJelEl;
      szx:=TPont(PontLista.Objects[j1]).sx-LatX-Round(((TPont(PontLista.Objects[j1]).sx-LatX)-
       (TPont(PontLista.Objects[j2]).sx-LatX))/2);
      szy:=TPont(PontLista.Objects[j1]).sy-LatY-Round(((TPont(PontLista.Objects[j1]).sy-LatY)-
       (TPont(PontLista.Objects[j2]).sy-LatY))/2);
      TextOut(szx-5,szy-5,IntToStr(TEl(ElLista.Objects[i]).h));
     end;
    end;
   If VanPont then
    for i:=0 to PDb-1 do begin
     if TPont(PontLista.Objects[i]).jel then begin
      Pen.Color:=clBlack;
      Brush.Color:=SzinJelPont;
     end
     else begin
      Pen.Color:=clBlack;
      Brush.Color:=SzinPont;
     end;
     Ellipse(TPont(PontLista.Objects[i]).sx-LatX-PontSugar,TPont(PontLista.Objects[i]).sy-LatY-PontSugar,
      TPont(PontLista.Objects[i]).sx-LatX+PontSugar,TPont(PontLista.Objects[i]).sy-LatY+PontSugar);
     if VanPontAzon then begin
      Font:=CimkeFont;
      s:=IntToStr(TPont(PontLista.Objects[i]).azon);
      if Round(Length(s)*Font.Size/2)<(PontSugar*2-10) then
       TextOut(TPont(PontLista.Objects[i]).sx-LatX-Round(Length(s)*Font.Size/3),
        TPont(PontLista.Objects[i]).sy-LatY+Round(Font.Height/2)-1,s);
     end;
    end;
  end;
 end;
 Valtozas:=False;
 with Canvas do begin
  Pen.Color:=clBlack;
  Brush.Color:=clLime;
  Ellipse(KeretSzel+5,Height-KeretSzel-USavMag+4,KeretSzel+18,Height-KeretSzel-USavMag+17);
 end;
end;

procedure TGraf.Paint;
begin
 MeretBeallitasok;
 with Canvas do begin
  Pen.Color:=clBlack;
  Brush.Color:=clBtnFace;
  Rectangle(KeretSzel,KeretSzel+TBMag,Width-KeretSzel+1,ISavMag+KeretSzel+TBMag);
  MoveTo(KeretSzel,KeretSzel+TBMag+ISavMag);
  LineTo(KeretSzel,Height-KeretSzel-USavMag);
  MoveTo(Width-KeretSzel,KeretSzel+TBMag+ISavMag);
  LineTo(Width-KeretSzel,Height-KeretSzel-USavMag);
 end;
 Info1(GrafNev);
 Info2('');
 Info3('');
 Uzenet('');
 if Valtozas then Rajzolas;
end;

procedure TGraf.NyilRajzolas(HonnanX,HonnanY,HovaX,HovaY: Integer);
var
 NX1,NX2,NX3,NY1,NY2,NY3: Integer;
 Beta: Real;
begin
 if (HovaX-HonnanX)=0 then
  if (HonnanY>HovaY) then Beta:=Pi/2
  else Beta:=-Pi/2
 else Beta:=ArcTan((HonnanY-HovaY)/(HovaX-HonnanX));
 if HonnanX<=HovaX then begin
  if VanPont then begin
   NX1:=Round(HovaX-Cos(Beta)*PontSugar);
   NY1:=Round(HovaY+Sin(Beta)*PontSugar);
  end
  else begin
   NX1:=HovaX;
   NY1:=HovaY;
  end;
  NX2:=Round(NX1-Cos(Beta+NyilSzog)*NyilHossz);
  NY2:=Round(NY1+Sin(Beta+NyilSzog)*NyilHossz);
  NX3:=Round(NX1-Cos(Beta-NyilSzog)*NyilHossz);
  NY3:=Round(NY1+Sin(Beta-NyilSzog)*NyilHossz);
 end
 else begin
  if VanPont then begin
   NX1:=Round(HovaX+Cos(Beta)*PontSugar);
   NY1:=Round(HovaY-Sin(Beta)*PontSugar);
  end
  else begin
   NX1:=HovaX;
   NY1:=HovaY;
  end;
  NX2:=Round(NX1+Cos(Beta+NyilSzog)*NyilHossz);
  NY2:=Round(NY1-Sin(Beta+NyilSzog)*NyilHossz);
  NX3:=Round(NX1+Cos(Beta-NyilSzog)*NyilHossz);
  NY3:=Round(NY1-Sin(Beta-NyilSzog)*NyilHossz);
 end;
 with RajzVaszon.Canvas do begin
  Polygon([Point(NX1,NY1),Point(NX2,NY2),Point(NX3,NY3),Point(NX1,NY1)]);
 end;
end;

{Az Infsv megjelentse}

procedure TGraf.Info1(const szoveg: string);
begin
 with Canvas do begin
  Brush.Color:=clBtnFace;
  Pen.Color:=clBtnFace;
  Rectangle(KeretSzel+2,KeretSzel+TBMag+2,KeretSzel+IPoz2+2,KeretSzel+TBMag+ISavMag-3);
  Pen.Color:=clGray;
  MoveTo(KeretSzel+2,KeretSzel+TBMag+ISavMag-3);
  LineTo(KeretSzel+2,KeretSzel+TBMag+2);
  LineTo(KeretSzel+IPoz2+2,KeretSzel+TBMag+2);
  Pen.Color:=clWhite;
  MoveTo(KeretSzel+3,KeretSzel+TBMag+ISavMag-3);
  LineTo(KeretSzel+IPoz2+2,KeretSzel+TBMag+ISavMag-3);
  LineTo(KeretSzel+IPoz2+2,KeretSzel+TBMag+2);
  Font.Name:='Arial';
  Font.Size:=8;
  Font.Style:=[fsBold];
  Font.Color:=clBlack;
  TextOut(KeretSzel+8,KeretSzel+TBMag+5,szoveg);
 end;
end;

procedure TGraf.Info2(const szoveg: string);
begin
 with Canvas do begin
  Brush.Color:=clBtnFace;
  Pen.Color:=clBtnFace;
  Rectangle(KeretSzel+IPoz2+4,KeretSzel+TBMag+2,KeretSzel+IPoz3+2,KeretSzel+TBMag+ISavMag-3);
  Pen.Color:=clGray;
  MoveTo(KeretSzel+IPoz2+4,KeretSzel+TBMag+ISavMag-3);
  LineTo(KeretSzel+IPoz2+4,KeretSzel+TBMag+2);
  LineTo(KeretSzel+IPoz3+2,KeretSzel+TBMag+2);
  Pen.Color:=clWhite;
  MoveTo(KeretSzel+IPoz2+5,KeretSzel+TBMag+ISavMag-3);
  LineTo(KeretSzel+IPoz3+2,KeretSzel+TBMag+ISavMag-3);
  LineTo(KeretSzel+IPoz3+2,KeretSzel+TBMag+2);
  Font.Name:='Arial';
  Font.Size:=8;
  Font.Style:=[fsBold];
  Font.Color:=clBlue;
  TextOut(KeretSzel+IPoz2+8,KeretSzel+TBMag+5,szoveg);
 end;
end;

procedure TGraf.Info3(const szoveg: string);
begin
 with Canvas do begin
  Brush.Color:=clBtnFace;
  Pen.Color:=clBtnFace;
  Rectangle(KeretSzel+IPoz3+4,KeretSzel+TBMag+2,Width-KeretSzel-2,KeretSzel+TBMag+ISavMag-3);
  Pen.Color:=clGray;
  MoveTo(KeretSzel+IPoz3+4,KeretSzel+TBMag+ISavMag-3);
  LineTo(KeretSzel+IPoz3+4,KeretSzel+TBMag+2);
  LineTo(Width-KeretSzel-2,KeretSzel+TBMag+2);
  Pen.Color:=clWhite;
  MoveTo(KeretSzel+IPoz3+5,KeretSzel+TBMag+ISavMag-3);
  LineTo(Width-KeretSzel-2,KeretSzel+TBMag+ISavMag-3);
  LineTo(Width-KeretSzel-2,KeretSzel+TBMag+2);
  Font.Style:=[fsBold];
  Font.Color:=clRed;
  TextOut(KeretSzel+IPoz3+8,KeretSzel+TBMag+5,szoveg);
 end;
end;

{Az zenetsv megjelentse}

procedure TGraf.Uzenet(const szoveg: string);
begin
 with Canvas do begin
  Pen.Color:=clBlack;
  Brush.Color:=clBtnFace;
  Rectangle(KeretSzel,Height-KeretSzel-USavMag,Width-KeretSzel+1,Height-KeretSzel);
  Pen.Color:=clGray;
  MoveTo(KeretSzel+2,Height-KeretSzel-3);
  LineTo(KeretSzel+2,Height-KeretSzel-USavMag+2);
  LineTo(Width-KeretSzel-3,Height-KeretSzel-USavMag+2);
  Pen.Color:=clWhite;
  MoveTo(KeretSzel+3,Height-KeretSzel-3);
  LineTo(Width-KeretSzel-3,Height-KeretSzel-3);
  LineTo(Width-KeretSzel-3,Height-KeretSzel-USavMag+2);
  Font.Name:='Arial';
  Font.Size:=8;
  Font.Style:=[fsBold];
  Font.Color:=clBlue;
  TextOut(5+KeretSzel,Height-KeretSzel-USavMag+5,szoveg);
 end;
end;

{A Scrollozst kezel metdusok}

procedure TGraf.HorScrollProc(Sender: TObject; ScrollCode: TScrollCode;
          var ScrollPos: Integer);
begin
 case ScrollCode of
  scLineUp: if LatX>0 then begin
             LatX:=LatX-ScrollKisValt;
             if LatX<0 then LatX:=0;
             Valtozas:=True;
             Paint;
            end;
  scLineDown: if LatX<Round(KepSzel*AranyHor)-RajzVaszon.Width then begin
               LatX:=LatX+ScrollKisValt;
               if LatX>Round(KepSzel*AranyHor)-RajzVaszon.Width then
                LatX:=Round(KepSzel*AranyHor)-RajzVaszon.Width;
               Valtozas:=True;
               Paint;
              end;
  scPageUp: if LatX>0 then begin
             LatX:=LatX-Round(RajzVaszon.Width/2);
             if LatX<0 then LatX:=0;
             Valtozas:=True;
             Paint;
            end;
  scPageDown: if LatX<Round(KepSzel*AranyHor)-RajzVaszon.Width then begin
               LatX:=LatX+Round(RajzVaszon.Width/2);
               if LatX>Round(KepSzel*AranyHor)-RajzVaszon.Width then
                LatX:=Round(KepSzel*AranyHor)-RajzVaszon.Width;
               Valtozas:=True;
               Paint;
              end;
  scPosition: begin
               LatX:=HorScroll.Position;
               if LatX>Round(KepSzel*AranyHor)-RajzVaszon.Width then
                LatX:=Round(KepSzel*AranyHor)-RajzVaszon.Width;
               Valtozas:=True;
               Paint;
              end;
 end;
end;

procedure TGraf.VerScrollProc(Sender: TObject; ScrollCode: TScrollCode;
          var ScrollPos: Integer);
begin
 case ScrollCode of
  scLineUp: if LatY>0 then begin
             LatY:=LatY-ScrollKisValt;
             if LatY<0 then LatY:=0;
             Valtozas:=True;
             Paint;
            end;
  scLineDown: if LatY<Round(KepMag*AranyVer)-RajzVaszon.Height then begin
               LatY:=LatY+ScrollKisValt;
               if LatY>Round(KepMag*AranyVer)-RajzVaszon.Height then
                LatY:=Round(KepMag*AranyVer)-RajzVaszon.Height;
               Valtozas:=True;
               Paint;
              end;
  scPageUp: if LatY>0 then begin
             LatY:=LatY-Round(RajzVaszon.Height/2);
             if LatY<0 then LatY:=0;
             Valtozas:=True;
             Paint;
            end;
  scPageDown: if LatY<Round(KepMag*AranyVer)-RajzVaszon.Height then begin
               LatY:=LatY+Round(RajzVaszon.Height/2);
               if LatY>Round(KepMag*AranyVer)-RajzVaszon.Height then
                LatY:=Round(KepMag*AranyVer)-RajzVaszon.Height;
               Valtozas:=True;
               Paint;
              end;
  scPosition: begin
               LatY:=VerScroll.Position;
               if LatY>Round(KepMag*AranyVer)-RajzVaszon.Height then
                LatY:=Round(KepMag*AranyVer)-RajzVaszon.Height;
               Valtozas:=True;
               Paint;
              end;
 end;
end;

{A beviteli mezbe bert stringet ellenrzi}

function TGraf.JoAdat(var s: string): Boolean;
var i: byte;
begin
 i:=Length(s);
 while (s[i]=' ') and (i>0) do Dec(i);
 s[0]:=Chr(i);
 i:=1;
 Result:=True;
 repeat
  if s[i]=' ' then Result:=False;
  Inc(i);
 until (i>Length(s)) or not(Result);
end;

{res esemnykezel metdusok}

procedure TGraf.MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
end;

procedure TGraf.MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
end;

procedure TGraf.Exit(Sender: TObject);
begin
end;

{A bevitelimez kilps esemnykezel metdusa}

procedure TGraf.EscKeyPress(Sender: TObject; var Key: Char);
begin
 if Key=#27 then begin
  PontAzonMezo.OnExit:=Exit;
  PontAzonMezo.Hide;
  ElHosszMezo.OnExit:=Exit;
  ElHosszMezo.Hide;
  RajzVaszon.OnMouseMove:=MouseMoveInfo;
  RajzVaszon.Cursor:=crDefault;
  RajzVaszon.OnMouseDown:=MouseDown;
  Uzenet('');
  GombokEnged;
  Valtozas:=True;
  Paint;
 end;
end;

{Egrmozgs a kirajzolt grf felett esemnykezel metdusa}

procedure TGraf.MouseMoveInfo(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var kx,ky,i: Longint;
begin
 if VanAdat then begin
  kx:=LatX+X; ky:=LatY+Y;
  Info2('('+IntToStr(MinX+Round(kx/AranyHor))+','+IntToStr(MaxY-Round(ky/AranyVer))+')');
  Info3('');
  for i:=0 to PDb-1 do
   if Round(Sqrt(Sqr(TPont(PontLista.Objects[i]).sx-kx)+
    Sqr(TPont(PontLista.Objects[i]).sy-ky)))<=PontSugar then begin
     Info3('Pont:  '+IntToStr(TPont(PontLista.Objects[i]).azon)+
      '  Koord.:  ('+IntToStr(TPont(PontLista.Objects[i]).x)+','+
      IntToStr(TPont(PontLista.Objects[i]).y)+')');
     Break;
  end;
 end;
end;

{Esemnykezel metdusok a nagytshoz, kicsinytshez}

procedure TGraf.Nagyit;
begin
 Nagyitas:=Nagyitas+10;
end;

procedure TGraf.Nagyit_Click(Sender: TObject);
begin
 Nagyit;
end;

procedure TGraf.Kicsinyit;
begin
 Nagyitas:=Nagyitas-10;
end;

procedure TGraf.Kicsinyit_Click(Sender: TObject);
begin
 Kicsinyit;
end;

procedure TGraf.Alaphelyzet;
begin
 Nagyitas:=100;
end;

procedure TGraf.Alaphelyzet_Click(Sender: TObject);
begin
 Alaphelyzet;
end;

{Nv adsa a grfhoz}

procedure TGraf.NevAdas;
begin
 GombokTilt;
 Uzenet('rja be a grf nevt (max. 20 kar.)!');
 GrafNevMezo.Text:=GrafNev;
 GrafNevMezo.OnExit:=NevTarolas;
 GrafNevMezo.Show;
 GrafNevMezo.SetFocus;
end;

procedure TGraf.NevAdas_Click(Sender: TObject);
begin
 NevAdas;
end;

procedure TGraf.NevTarolas(Sender: TObject);
begin
 GrafNevMezo.Hide;
 GrafNev:=GrafNevMezo.Text;
 GombokEnged;
 Uzenet('');
end;

{Azonost ajnlsa egy j ponthoz}

function TGraf.JavasoltAzonosito: string;
var i,max: Integer;
begin
 max:=-1;
 if PontLista.Count=0 then Result:='1'
 else begin
  for i:=0 to PontLista.Count-1 do
   if StrToInt(PontLista[i])>max then max:=StrToInt(PontLista[i]);
  Result:=IntToStr(max+1);
 end;
end;

{j pontok felvtele}

procedure TGraf.UjPont;
begin
 if PDb<16368 then begin
  GombokTilt;
  RajzVaszon.Cursor:=crCross;
  RajzVaszon.OnMouseDown:=MouseDownUjPont;
  Uzenet('Jellje ki az j pont helyt az egrrel!   (Esc: jobb egrgomb)');
 end
 else Uzenet('Tbb pont nem vehet fel!');
end;

procedure TGraf.UjPont_Click(Sender: TObject);
begin
 UjPont;
end;

procedure TGraf.MouseDownUjPont(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 if Button=mbLeft then begin
  FSegedPont.sx:=LatX+X;
  FSegedPont.sy:=LatY+Y;
  FSegedPont.x:=MinX+Round(FSegedPont.sx/AranyHor);
  FSegedPont.y:=MinY+(MaxY-MinY)-Round(FSegedPont.sy/AranyVer);
  if VanPont then
   with RajzVaszon.Canvas do begin
    Pen.Color:=clBlack;
    Brush.Color:=FSzinPont;
    Ellipse(FSegedPont.sx-LatX-PontSugar,FSegedPont.sy-LatY-PontSugar,
     FSegedPont.sx-LatX+PontSugar,FSegedPont.sy-LatY+PontSugar);
   end;
  RajzVaszon.Cursor:=crDefault;
  RajzVaszon.OnMouseDown:=MouseDown;
  RajzVaszon.OnMouseMove:=MouseMove;
  Uzenet('rja be a pont azonostjt!');
  PontAzonMezo.Text:=JavasoltAzonosito;
  PontAzonMezo.OnExit:=PontTarolas;
  PontAzonMezo.OnKeyPress:=EscKeyPress;
  PontAzonMezo.Show;
  PontAzonMezo.SetFocus;
 end;
 if Button=mbRight then begin
  RajzVaszon.Cursor:=crDefault;
  RajzVaszon.OnMouseDown:=MouseDown;
  Uzenet('');
  GombokEnged;
  Valtozas:=True;
  Paint;
 end;
end;

procedure TGraf.PontTarolas(Sender: TObject);
var pazon: Word;
    s: string;
    Index: Integer;
    PO: TPont;
begin
 if PontAzonMezo.Text='' then PontAzonMezo.SetFocus
 else begin
  pazon:=0;
  s:=PontAzonMezo.Text;
  if JoAdat(s) then pazon:=StrToInt(s);
  if ((pazon>0) and (pazon<=16368)) and
   not(PontLista.Find(PontListaAzonKeszit(pazon),Index)) then begin
   FSegedPont.azon:=pazon;
   PontAzonMezo.Hide;
   RajzVaszon.OnMouseMove:=MouseMoveInfo;
   PO:=TPont.Create(FSegedPont.azon,FSegedPont.x,FSegedPont.y,FSegedPont.sx,FSegedPont.sy,False);
   if Assigned(PO) then begin
    PontLista.AddObject(PontListaAzonKeszit(FSegedPont.azon),PO);
    PDb:=PDb+1;
    MentSzuks:=True;
    Valtozas:=True;
    Paint;
    RajzVaszon.Cursor:=crCross;
    RajzVaszon.OnMouseDown:=MouseDownUjPont;
    Uzenet('Jellje ki az j pont helyt az egrrel!   (Esc: jobb egrgomb)');
   end
   else begin
    NincsTobbMemoria;
    RajzVaszon.Cursor:=crDefault;
    RajzVaszon.OnMouseDown:=MouseDown;
    Uzenet('');
    GombokEnged;
    Valtozas:=True;
    Paint;
   end;
  end
  else begin
   Uzenet('rvnytelen azonost, prbljon msikat adni!');
   PontAzonMezo.Text:=JavasoltAzonosito;
   PontAzonMezo.SetFocus;
  end;
 end;
end;

{Pontok helynek mdostsa}

procedure TGraf.PontHelyMod;
begin
 GombokTilt;
 RajzVaszon.Cursor:=crCross;
 RajzVaszon.OnMouseDown:=MouseDownPontHelyMod1;
 Uzenet('Jellje ki a mdostand pontot az egrrel!   (Esc: jobb egrgomb)');
end;

procedure TGraf.PontHelyMod_Click(Sender: TObject);
begin
 PontHelyMod;
end;

procedure TGraf.MouseDownPontHelyMod1(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var kx,ky: Longint;
    i: Integer;
    letezopont: Boolean;
begin
 if Button=mbLeft then begin
   kx:=LatX+X; ky:=LatY+Y;
   letezopont:=False;
   for i:=0 to PDb-1 do
    if Round(Sqrt(Sqr(TPont(PontLista.Objects[i]).sx-kx)+
     Sqr(TPont(PontLista.Objects[i]).sy-ky)))<=PontSugar then begin
     ModPontIndex:=i;
     letezopont:=True;
     Uzenet('Jellje ki a pont j helyt az egrrel!   (Esc: jobb egrgomb)');
     RajzVaszon.OnMouseDown:=MouseDownPontHelyMod2;
     Break;
    end;
   if not(letezopont) then Uzenet('Ezen a helyen nincsen pont. Prblkozzon mshol!');
 end;
 if Button=mbRight then begin
  RajzVaszon.Cursor:=crDefault;
  RajzVaszon.OnMouseDown:=MouseDown;
  Uzenet('');
  GombokEnged;
 end;
end;

procedure TGraf.MouseDownPontHelyMod2(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 if Button=mbLeft then begin
  TPont(PontLista.Objects[ModPontIndex]).sx:=LatX+X;
  TPont(PontLista.Objects[ModPontIndex]).sy:=LatY+Y;
  TPont(PontLista.Objects[ModPontIndex]).x:=MinX+Round(TPont(PontLista.Objects[ModPontIndex]).sx/AranyHor);
  TPont(PontLista.Objects[ModPontIndex]).y:=MinY+(MaxY-MinY)-Round(TPont(PontLista.Objects[ModPontIndex]).sy/AranyVer);
  MentSzuks:=True;
  Valtozas:=True;
  Paint;
  RajzVaszon.Cursor:=crCross;
  RajzVaszon.OnMouseDown:=MouseDownPontHelyMod1;
  Uzenet('Jellje ki a mdostand pont helyt az egrrel!   (Esc: jobb egrgomb)');
 end;
 if Button=mbRight then begin
  RajzVaszon.Cursor:=crDefault;
  RajzVaszon.OnMouseDown:=MouseDown;
  Uzenet('');
  GombokEnged;
  Valtozas:=True;
  Paint;
 end;
end;

{Pontok kijellse}

procedure TGraf.PontKijelol;
begin
 Uzenet('Jellje ki a pont helyt az egrrel!   (Esc: jobb egrgomb)');
 GombokTilt;
 RajzVaszon.Cursor:=crCross;
 RajzVaszon.OnMouseDown:=MouseDownPontKijelol;
end;

procedure TGraf.PontKijelol_Click(Sender: TObject);
begin
 PontKijelol;
end;

procedure TGraf.MouseDownPontKijelol(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var kx,ky: Longint;
    i: Integer;
    letezopont: Boolean;
begin
 if Button=mbLeft then begin
   kx:=LatX+X; ky:=LatY+Y;
   letezopont:=False;
   for i:=0 to PDb-1 do
    if Round(Sqrt(Sqr(TPont(PontLista.Objects[i]).sx-kx)+
     Sqr(TPont(PontLista.Objects[i]).sy-ky)))<=PontSugar then begin
     TPont(PontLista.Objects[i]).jel:=not(TPont(PontLista.Objects[i]).jel);
     letezopont:=True;
     MentSzuks:=True;
     Valtozas:=True;
     Paint;
     Uzenet('Jellje ki a pont helyt az egrrel!   (Esc: jobb egrgomb)');
     Break;
    end;
   if not(letezopont) then Uzenet('Ezen a helyen nincsen pont.');
 end;
 if Button=mbRight then begin
  RajzVaszon.Cursor:=crDefault;
  RajzVaszon.OnMouseDown:=MouseDown;
  Uzenet('');
  GombokEnged;
 end;
end;

{Pontok trlse}

procedure TGraf.PontTorol;
begin
 Uzenet('Jellje ki a trlend pontot az egrrel !   (Esc: jobb egrgomb)');
 GombokTilt;
 RajzVaszon.Cursor:=crCross;
 RajzVaszon.OnMouseDown:=MouseDownTorlPont;
end;

procedure TGraf.PontTorol_Click(Sender: TObject);
begin
 PontTorol;
end;

procedure TGraf.MouseDownTorlPont(Sender: TObject; Button: TMouseButton;
          Shift: TShiftState; X, Y: Integer);
var kx,ky: Longint;
    i,j: Integer;
    segedaz: Word;
    letezopont: Boolean;
begin
 if Button=mbLeft then begin
   kx:=LatX+X; ky:=LatY+Y;
   letezopont:=false;
   for i:=0 to PDb-1 do
    if Round(Sqrt(Sqr(TPont(PontLista.Objects[i]).sx-kx)+
     Sqr(TPont(PontLista.Objects[i]).sy-ky)))<=PontSugar then begin
      segedaz:=TPont(PontLista.Objects[i]).azon;
      j:=0;
      while (j<EDb) do begin
       if (TEl(ElLista.Objects[j]).p1=segedaz) or (TEl(ElLista.Objects[j]).p2=segedaz) then begin
        ElLista.Delete(j);
        EDb:=EDb-1;
       end
       else Inc(j);
      end;
      PontLista.Delete(i);
      PDb:=PDb-1;
      MentSzuks:=True;
      letezopont:=True;
      Valtozas:=True;
      Paint;
      Break;
    end;
   if not(letezopont) then
    Uzenet('Ezen a helyen nincsen pont, prblkozzon mshol!');
 end;
 if Button=mbRight then begin
  RajzVaszon.Cursor:=crDefault;
  RajzVaszon.OnMouseDown:=MouseDown;
  Uzenet('');
  GombokEnged;
 end;
end;

{lek felvtele}

procedure TGraf.UjEl;
begin
 if EDb<16368 then begin
  GombokTilt;
  RajzVaszon.Cursor:=crCross;
  RajzVaszon.OnMouseDown:=MouseDownUjEl1;
  Uzenet('Jellje ki az j l kezdpontjt az egrrel!   (Esc: jobb egrgomb)');
 end
 else Uzenet('Tbb l nem vehet fel!');
end;

procedure TGraf.UjEl_Click(Sender: TObject);
begin
 UjEl;
end;

procedure TGraf.MouseDownUjEl1(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var kx,ky: Longint;
    i: Integer;
begin
 if Button=mbLeft then begin
  kx:=LatX+X; ky:=LatY+Y;
  for i:=0 to PDb-1 do
   if Round(Sqrt(Sqr(TPont(PontLista.Objects[i]).sx-kx)+
    Sqr(TPont(PontLista.Objects[i]).sy-ky)))<=PontSugar then begin
     FSegedEl.p1:=TPont(PontLista.Objects[i]).azon;
     RajzVaszon.OnMouseDown:=MouseDownUjEl2;
     Uzenet('Jellje ki az l vgpontjt az egrrel!   (Esc: jobb egrgomb)');
   end;
 end;
 if Button=mbRight then begin
  RajzVaszon.Cursor:=crDefault;
  RajzVaszon.OnMouseDown:=MouseDown;
  RajzVaszon.OnMouseMove:=MouseMoveInfo;
  Uzenet('');
  GombokEnged;
 end;
end;

procedure TGraf.MouseDownUjEl2(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var kx,ky: Longint;
    i,j: Integer;
    letezoel,kellhossz: Boolean;
    EO: TEl;
begin
 if Button=mbLeft then begin
  kx:=LatX+X; ky:=LatY+Y;
  for i:=0 to PDb-1 do
   if Round(Sqrt(Sqr(TPont(PontLista.Objects[i]).sx-kx)+
    Sqr(TPont(PontLista.Objects[i]).sy-ky)))<=PontSugar then begin
     FSegedEl.p2:=TPont(PontLista.Objects[i]).azon;
     letezoel:=false;
     if FSegedEl.p1<>FSegedEl.p2 then begin
      for j:=0 to EDb-1 do
       if (TEl(ElLista.Objects[j]).p1=FSegedEl.p1) and (TEl(ElLista.Objects[j]).p2=FSegedEl.p2) then begin
        letezoel:=true;
        Break;
       end;
      if letezoel then begin
       Uzenet('Ilyen l mr ltezik, prblkozzon msikkal!');
       RajzVaszon.Cursor:=crCross;
       RajzVaszon.OnMouseDown:=MouseDownUjEl1;
       RajzVaszon.OnMouseMove:=MouseMoveInfo;
      end
      else begin
       kellhossz:=True;
       for j:=0 to EDb-1 do
        if (TEl(ElLista.Objects[j]).p2=FSegedEl.p1) and (TEl(ElLista.Objects[j]).p1=FSegedEl.p2) then begin
         kellhossz:=False;
         EO:=TEl.Create(TEl(ElLista.Objects[j]).h,FSegedEl.p1,FSegedEl.p2,False);
         if Assigned(EO) then begin
          EDb:=EDb+1;
          ElLista.AddObject(ElListaAzonKeszit(FSegedEl.p1,FSegedEl.p2),EO);
          MentSzuks:=True;
          Valtozas:=True;
          Paint;
          RajzVaszon.Cursor:=crCross;
          RajzVaszon.OnMouseDown:=MouseDownUjEl1;
          RajzVaszon.OnMouseMove:=MouseMoveInfo;
          Uzenet('Jellje ki az j l kezdpontjt az egrrel!   (Esc: jobb egrgomb)');
         end
         else begin
          NincsTobbMemoria;
          RajzVaszon.Cursor:=crDefault;
          RajzVaszon.OnMouseDown:=MouseDown;
          RajzVaszon.OnMouseMove:=MouseMoveInfo;
          Uzenet('');
          GombokEnged;
         end;
         Break;
        end;
       if kellhossz then begin
        RajzVaszon.OnMouseDown:=MouseDown;
        RajzVaszon.Cursor:=crDefault;
        RajzVaszon.OnMouseMove:=MouseMove;
        Uzenet('rja be az j l hosszt!');
        ElHosszMezo.Text:=IntToStr(ElHosszAlap);
        ElHosszMezo.OnExit:=ElTarolas;
        ElHosszMezo.OnKeyPress:=EscKeyPress;
        ElHosszMezo.Show;
        ElHosszMezo.SetFocus;
       end;
      end;
      Break;
     end
     else begin
      Uzenet('Egyazon pont nem lehet az l kezdete s vge!');
      RajzVaszon.Cursor:=crCross;
      RajzVaszon.OnMouseDown:=MouseDownUjEl1;
      RajzVaszon.OnMouseMove:=MouseMoveInfo;
     end;
   end;
 end;
 if Button=mbRight then begin
  RajzVaszon.Cursor:=crDefault;
  RajzVaszon.OnMouseDown:=MouseDown;
  RajzVaszon.OnMouseMove:=MouseMoveInfo;
  Uzenet('');
  GombokEnged;
 end;
end;

procedure TGraf.ElTarolas(Sender: TObject);
var segedhossz: Longint;
    EO: TEl;
    s: string;
begin
 if ElHosszMezo.Text='' then ElHosszMezo.SetFocus
 else begin
  segedhossz:=-1;
  s:=ElHosszMezo.Text;
  if JoAdat(s) then segedhossz:=StrToInt(s);
  if ((segedhossz>=0) and (segedhossz<1000000)) then begin
   FSegedEl.h:=segedhossz;
   ElHosszMezo.Hide;
   EO:=TEl.Create(FSegedEl.h,FSegedEl.p1,FSegedEl.p2,False);
   if Assigned(EO) then begin
    EDb:=EDb+1;
    ElLista.AddObject(ElListaAzonKeszit(FSegedEl.p1,FSegedEl.p2),EO);
    MentSzuks:=True;
    Valtozas:=True;
    Paint;
    RajzVaszon.Cursor:=crCross;
    RajzVaszon.OnMouseDown:=MouseDownUjEl1;
    RajzVaszon.OnMouseMove:=MouseMoveInfo;
    Uzenet('Jellje ki az j l kezdpontjt az egrrel!   (Esc: jobb egrgomb)');
   end
   else begin
    NincsTobbMemoria;
    RajzVaszon.Cursor:=crDefault;
    RajzVaszon.OnMouseDown:=MouseDown;
    RajzVaszon.OnMouseMove:=MouseMoveInfo;
    Uzenet('');
    GombokEnged;
   end;
  end
  else begin
   Uzenet('rvnytelen hossz, prbljon msikat adni!');
   ElHosszMezo.SetFocus;
  end;
 end;
end;

{lek kijellse}

procedure TGraf.ElKijelol;
begin
 Uzenet('Jellje ki a kezdpont helyt az egrrel!   (Esc: jobb egrgomb)');
 GombokTilt;
 RajzVaszon.Cursor:=crCross;
 RajzVaszon.OnMouseDown:=MouseDownElKijelol1;
end;

procedure TGraf.ElKijelol_Click(Sender: TObject);
begin
 ElKijelol;
end;

procedure TGraf.MouseDownElKijelol1(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var kx,ky: Longint;
    i: Integer;
begin
 if Button=mbLeft then begin
  kx:=LatX+X; ky:=LatY+Y;
  for i:=0 to PDb-1 do
   if Round(Sqrt(Sqr(TPont(PontLista.Objects[i]).sx-kx)+
    Sqr(TPont(PontLista.Objects[i]).sy-ky)))<=PontSugar then begin
     FSegedEl.p1:=TPont(PontLista.Objects[i]).azon;
     RajzVaszon.OnMouseDown:=MouseDownElKijelol2;
     Uzenet('Jellje ki az l vgpontjt az egrrel!   (Esc: jobb egrgomb)');
     Break;
   end;
 end;
 if Button=mbRight then begin
  RajzVaszon.Cursor:=crDefault;
  RajzVaszon.OnMouseDown:=MouseDown;
  Uzenet('');
  GombokEnged;
 end;
end;

procedure TGraf.MouseDownElKijelol2(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var kx,ky: Longint;
    i,j: Integer;
    EO: TEl;
    letezoel: Boolean;
begin
 if Button=mbLeft then begin
  kx:=LatX+X; ky:=LatY+Y;
  for i:=0 to PDb-1 do
   if Round(Sqrt(Sqr(TPont(PontLista.Objects[i]).sx-kx)+
    Sqr(TPont(PontLista.Objects[i]).sy-ky)))<=PontSugar then begin
     FSegedEl.p2:=TPont(PontLista.Objects[i]).azon;
     letezoel:=false;
     for j:=0 to EDb-1 do
      if (TEl(ElLista.Objects[j]).p1=FSegedEl.p1) and (TEl(ElLista.Objects[j]).p2=FSegedEl.p2) then begin
       TEl(ElLista.Objects[j]).jel:=not(TEl(ElLista.Objects[j]).jel);
       letezoel:=true;
       MentSzuks:=True;
       Valtozas:=True;
       Paint;
       Uzenet('Jellje ki az l kezdpontjt az egrrel!   (Esc: jobb egrgomb)');
       Break;
      end;
     if not(letezoel) then Uzenet('Nincs ilyen l, jellje ki az l kezdpontjt az egrrel!');
     RajzVaszon.OnMouseDown:=MouseDownElKijelol1;
    end;
 end;
 if Button=mbRight then begin
  RajzVaszon.Cursor:=crDefault;
  RajzVaszon.OnMouseDown:=MouseDown;
  Uzenet('');
  GombokEnged;
 end;
end;

{lek trlse}

procedure TGraf.ElTorol;
begin
 Uzenet('Jellje ki a trlend l kezdpontjt az egrrel!   (Esc: jobb egrgomb)');
 GombokTilt;
 RajzVaszon.Cursor:=crCross;
 RajzVaszon.OnMouseDown:=MouseDownTorlEl1;
end;

procedure TGraf.ElTorol_Click(Sender: TObject);
begin
 ElTorol;
end;

procedure TGraf.MouseDownTorlEl1(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var kx,ky: Longint;
    i: Integer;
begin
 if Button=mbLeft then begin
  kx:=LatX+X; ky:=LatY+Y;
  for i:=0 to PDb-1 do
   if Round(Sqrt(Sqr(TPont(PontLista.Objects[i]).sx-kx)+Sqr(TPont(PontLista.Objects[i]).sy-ky)))<=PontSugar then begin
     FSegedEl.p1:=TPont(PontLista.Objects[i]).azon;
     RajzVaszon.OnMouseDown:=MouseDownTorlEl2;
     Uzenet('Jellje ki a trlend l vgpontjt az egrrel!   (Esc: jobb egrgomb)');
   end;
 end;
 if Button=mbRight then begin
  RajzVaszon.Cursor:=crDefault;
  RajzVaszon.OnMouseDown:=MouseDown;
  Uzenet('');
  GombokEnged;
 end;
end;

procedure TGraf.MouseDownTorlEl2(Sender: TObject; Button: TMouseButton;
          Shift: TShiftState; X, Y: Integer);
var kx,ky: Longint;
    i,j: Integer;
    EO: TEl;
    letezoel: Boolean;
begin
 if Button=mbLeft then begin
  kx:=LatX+X; ky:=LatY+Y;
  for i:=0 to PDb-1 do
   if Round(Sqrt(Sqr(TPont(PontLista.Objects[i]).sx-kx)+Sqr(TPont(PontLista.Objects[i]).sy-ky)))<=PontSugar then begin
     FSegedEl.p2:=TPont(PontLista.Objects[i]).azon;
     letezoel:=false;
     for j:=0 to EDb-1 do
      if (TEl(ElLista.Objects[j]).p1=FSegedEl.p1) and
       (TEl(ElLista.Objects[j]).p2=FSegedEl.p2) then begin
       letezoel:=true;
       ElLista.Delete(j);
       EDb:=EDb-1;
       MentSzuks:=True;
       Valtozas:=True;
       Paint;
       Uzenet('Jellje ki az trlend l kezdpontjt az egrrel!   (Esc: jobb egrgomb)');
       Break;
      end;
     if not(letezoel) then Uzenet('Nincs ilyen l, prblkozzon jra!');
     RajzVaszon.OnMouseDown:=MouseDownTorlEl1;
    end;
 end;
 if Button=mbRight then begin
  RajzVaszon.Cursor:=crDefault;
  RajzVaszon.OnMouseDown:=MouseDown;
  Uzenet('');
  GombokEnged;
 end;
end;

{A kpernyn lthat grf msolsa a vglapra}

procedure TGraf.ClipboardraMasol;
var Bitmap: TBitmap;
begin
 Bitmap:=TBitmap.Create;
 Bitmap.Assign(RajzVaszon.Picture);
 Bitmap.Width:=RajzVaszon.Width;
 Bitmap.Height:=RajzVaszon.Height;
 Clipboard.Assign(Bitmap);
 Bitmap.Free;
end;

procedure TGraf.ClipboardraMasol_Click(Sender: TObject);
begin
 ClipboardraMasol;
end;

{Spinner esemnykezel metdusa}

procedure TGraf.PontSugarValtozas(Sender: TObject);
begin
 if (Spinner.Value>0) and (Spinner.Value<21) then PontSugar:=Spinner.Value
 else Spinner.Value:=PontSugar;
end;

{Jellemzk rtkt bellt metdusok}

procedure TGraf.SetGrafFajl(Value: string);
var
 sor,s1,s2,s3: string;
 i,j,tol,db: Integer;
 spont: rpont;
 sel: rel;
 EO: TEl;
 PO: TPont;
 Jelzett, Hibas: Boolean;
 FileAzon: TextFile;
 MaxW,MaxH: Longint;
begin
 Hibas:=False;
 FGrafFajl:=Value;
 if FileExists(Value) then begin
  Uzenet('Betlts folyamatban...');
  PontLista.Clear;
  ElLista.Clear;
  AssignFile(FileAzon,GrafFajl);
  Reset(FileAzon);
  s1:=GrafFajl;
  while s1[1]<>'.' do
   s1:=Copy(s1,2,Length(s1)-1);
  if (s1='.GJ') or (s1='.gj') then Jelzett:=True
  else Jelzett:=False;
  if Jelzett then begin
   ReadLn(FileAzon,s2);
   GrafNev:=Copy(s2,1,20);
  end
  else GrafNev:='';
  ReadLn(FileAzon,sor);
  PDb:=StrToInt(sor);
  if (PDb<0) or (PDb>16368) then Hibas:=True;
  i:=1;
  while not(Hibas) and (i<=PDb) do begin
   ReadLn(FileAzon,sor);
   j:=1;
   while (sor[j]=' ') do Inc(j);
   tol:=j; db:=0;
   while (sor[j]<>' ') do begin Inc(j); Inc(db); end;
   try
    spont.azon:=StrToInt(Copy(sor,tol,db));
    while (sor[j]=' ') do Inc(j);
    tol:=j; db:=0;
    while (sor[j]<>' ') do begin Inc(j); Inc(db); end;
    spont.x:=StrToInt(Copy(sor,tol,db));
    while (sor[j]=' ') do Inc(j);
    tol:=j; db:=0;
    if Jelzett then begin
     while (sor[j]<>' ') do begin Inc(j); Inc(db); end;
     spont.y:=StrToInt(Copy(sor,tol,db));
     tol:=j;
     spont.jel:=Boolean(StrToInt(sor[tol+1]));
    end
    else begin
     db:=Length(sor)-tol+1;
     spont.y:=StrToInt(Copy(sor,tol,db));
     spont.jel:=False;
    end;
    if (spont.azon<1) or (spont.azon>16368) or (spont.x<KoordMin) or
     (spont.x>KoordMax) or (spont.y<KoordMin)  or (spont.y>KoordMax) then Hibas:=True
    else begin
     PO:=TPont.Create(spont.azon,spont.x,spont.y,spont.sx,spont.sy,spont.jel);
     if Assigned(PO) then PontLista.AddObject(PontListaAzonKeszit(spont.azon),PO)
     else begin
      NincsTobbMemoria;
      Break;
     end;
    end;
    Inc(i);
   except
    on EConvertError do Hibas:=True;
   end;
  end;
  PDb:=PontLista.Count;
  if not(Hibas) then begin
   ReadLn(FileAzon,sor);
   EDb:=StrToInt(sor);
   if (EDb<0) or (EDb>16368) then Hibas:=True;
  end;
  i:=1;
  while not(Hibas) and (i<=EDb) do begin
   ReadLn(FileAzon,sor);
   j:=1;
   while (sor[j]=' ') do Inc(j);
   tol:=j; db:=0;
   while (sor[j]<>' ') do begin Inc(j); Inc(db); end;
   try
    sel.p1:=StrToInt(Copy(sor,tol,db));
    while (sor[j]=' ') do Inc(j);
    tol:=j; db:=0;
    while (sor[j]<>' ') do begin Inc(j); Inc(db); end;
    sel.p2:=StrToInt(Copy(sor,tol,db));
    while (sor[j]=' ') do Inc(j);
    tol:=j; db:=0;
    if Jelzett then begin
     while (sor[j]<>' ') do begin Inc(j); Inc(db); end;
     sel.h:=StrToInt(Copy(sor,tol,db));
     tol:=j;
     sel.jel:=Boolean(StrToInt(sor[tol+1]));
    end
    else begin
     db:=Length(sor)-tol+1;
     sel.h:=StrToInt(Copy(sor,tol,db));
     sel.jel:=False;
    end;
    if PontLista.Find(PontListaAzonKeszit(sel.p1),j) and
     PontLista.Find(PontListaAzonKeszit(sel.p2),j) and (sel.h>=0) and (sel.h<=999999) then begin
     EO:=TEl.Create(sel.h,sel.p1,sel.p2,sel.jel);
     if Assigned(EO) then ElLista.AddObject(ElListaAzonKeszit(sel.p1,sel.p2),EO)
     else begin
      NincsTobbMemoria;
      Break;
     end;
    end
    else Hibas:=True;
    Inc(i);
   except
    on EConvertError do Hibas:=True;
   end;
  end;
  EDb:=ElLista.Count;
  CloseFile(FileAzon);
  MentSzuks:=False;
  if Hibas then begin
   PontLista.Clear;
   ElLista.Clear;
   PDb:=0;
   EDb:=0;
   HibasFajl;
  end
  else begin
   Nagyitas:=100;
   ElozoNagyitas:=100;
   MaxX:=-10000000; MaxY:=-10000000; MinX:=10000000; MinY:=10000000;
   for i:=0 to PDb-1 do begin
    if TPont(PontLista.Objects[i]).x>MaxX then MaxX:=TPont(PontLista.Objects[i]).x;
    if TPont(PontLista.Objects[i]).x<MinX then MinX:=TPont(PontLista.Objects[i]).x;
    if TPont(PontLista.Objects[i]).y>MaxY then MaxY:=TPont(PontLista.Objects[i]).y;
    if TPont(PontLista.Objects[i]).y<MinY then MinY:=TPont(PontLista.Objects[i]).y;
   end;
   maxW:=MaxX-MinX;
   maxH:=MaxY-MinY;
   MinX:=MinX-Round(maxW/20);
   MinY:=MinY-Round(maxH/20);
   MaxX:=MaxX+Round(maxW/20);
   MaxY:=MaxY+Round(maxH/20);
   KepSzel:=MaxX-MinX;
   KepMag:=MaxY-MinY;
   if KepSzel<RajzVaszon.Width then begin
    KepSzel:=RajzVaszon.Width;
    MinX:=0;
   end;
   if KepMag<RajzVaszon.Height then begin
    KepMag:=RajzVaszon.Height;
    MaxY:=KepMag;
   end;
   LatX:=0; LatY:=0;
   MeretBeallitasok;
   KoordinataSzamol;
   HorScroll.Max:=0;
   HorScroll.Position:=0;
   VerScroll.Max:=0;
   VerScroll.Position:=0;
   VanAdat:=True;
   GombokEnged;
   Info1(GrafNev);
   Info2('');
   Info3('');
   Uzenet('');
  end;
 end
 else VanAdat:=False;
 Valtozas:=True;
 Paint;
end;

procedure TGraf.SetNagyitas(Value: Word);
var sAranyHor,sAranyVer: Real;
begin
 if (Value<>FNagyitas) then
  if (Value>=100) then begin
   sAranyHor:=(RajzVaszon.Width/KepSzel)*(Value/100);
   sAranyVer:=(RajzVaszon.Height/KepMag)*(Value/100);
   if (Round(KepSzel*sAranyHor-RajzVaszon.Width)<32768) and
    (Round(KepMag*sAranyVer-RajzVaszon.Height)<32768) then begin
    ElozoNagyitas:=FNagyitas;
    FNagyitas:=Value;
    KoordinataSzamol;
    Valtozas:=True;
    Paint;
   end
   else
    MessageDlg('Ekkora nagyts nem megvalsthat!',mtInformation,[mbOk],0);
  end;
end;

procedure TGraf.SetPontSugar(Value: Integer);
begin
 if (Value<>FPontSugar) and (Value>0) and (Value<=20) then begin
  FPontSugar:=Value;
  Valtozas:=True;
  Paint;
 end;
end;

procedure TGraf.SetVanElAdat(Value: Boolean);
begin
 if (Value<>FVanElAdat) then begin
  FVanElAdat:=Value;
  Valtozas:=True;
  Paint;
 end;
end;

procedure TGraf.SetVanPont(Value: Boolean);
begin
 if (Value<>FVanPont) then begin
  FVanPont:=Value;
  Valtozas:=True;
  Paint;
 end;
end;

procedure TGraf.SetVanPontAzon(Value: Boolean);
begin
 if (Value<>FVanPontAzon) then begin
  FVanPontAzon:=Value;
  Valtozas:=True;
  Paint;
 end;
end;

procedure TGraf.SetVanNyil(Value: Boolean);
begin
 if (Value<>FVanNyil) then begin
  FVanNyil:=Value;
  Valtozas:=True;
  Paint;
 end;
end;

procedure TGraf.SetNyilHossz(Value: Byte);
begin
 if (Value<>FNyilHossz) and (Value>4) and (Value<21) then begin
  FNyilHossz:=Value;
  Valtozas:=True;
  Paint;
 end;
end;

procedure TGraf.SetVanEl(Value: Boolean);
begin
 if (Value<>FVanEl) then begin
  FVanEl:=Value;
  Valtozas:=True;
  Paint;
 end;
end;

procedure TGraf.SetSzinEl(Value: TColor);
begin
 if (Value<>FSzinEl) then begin
  FSzinEl:=Value;
  Valtozas:=True;
  Paint;
 end;
end;

procedure TGraf.SetSzinJelPont(Value: TColor);
begin
 if (Value<>FSzinJelPont) then begin
  FSzinJelPont:=Value;
  Valtozas:=True;
  Paint;
 end;
end;

procedure TGraf.SetSzinJelEl(Value: TColor);
begin
 if (Value<>FSzinJelEl) then begin
  FSzinJelEl:=Value;
  Valtozas:=True;
  Paint;
 end;
end;

procedure TGraf.SetSzinPont(Value: TColor);
begin
 if (Value<>FSzinPont) then begin
  FSzinPont:=Value;
  Valtozas:=True;
  Paint;
 end;
end;

procedure TGraf.SetSzinKepernyo(Value: TColor);
begin
 if (Value<>FSzinKepernyo) then begin
  FSzinKepernyo:=Value;
  Valtozas:=True;
  Paint;
 end;
end;

procedure TGraf.SetCimkeFont(Value: TFont);
begin
 FCimkeFont.Assign(Value);
 Valtozas:=True;
 Paint;
end;

procedure TGraf.SetVanToolBar(Value: Boolean);
begin
 if (Value<>FVanToolBar) then begin
  FVanToolBar:=Value;
  if Value then begin
   TBMag:=30;
   GombokEnged;
  end
  else begin
   TBMag:=0;
   GombokTilt;
  end;
  MeretBeallitasok;
  KoordinataSzamol;
  with Canvas do begin
   Pen.Color:=clBtnFace;
   Brush.Color:=clBtnFace;
   Rectangle(KeretSzel,KeretSzel,Width-KeretSzel+1,KeretSzel+TBMag);
  end;
  Valtozas:=True;
  Refresh;
 end;
end;

procedure TGraf.SetGrafNev(Value: TGrafNev);
begin
 if (Value<>FGrafNev) then begin
  FGrafNev:=Value;
  Info1(GrafNev);
  MentSzuks:=True;
 end;
end;

procedure TGraf.SetElHosszAlap(Value: Longint);
begin
 if (Value<>FElHosszAlap) and (Value>=0) and (Value<1000000) then FElHosszAlap:=Value;
end;

{A ToolBar gombjainak tiltsa, engedlyezse}

procedure TGraf.GombokTilt;
var i: Integer;
begin
 for i:=1 to GombDb do begin
  if VanToolBar then FGombok[i].Show else FGombok[i].Hide;
  FGombok[i].Enabled:=False;
  FGombok[i].ShowHint:=False;
 end;
 if VanToolBar then Spinner.Show else Spinner.Hide;
 Spinner.Enabled:=False;
end;

procedure TGraf.GombokEnged;
var i: Integer;
begin
 for i:=1 to GombDb do begin
  if VanToolBar then FGombok[i].Show else FGombok[i].Hide;
  if i<3 then begin
   FGombok[i].Enabled:=True;
   FGombok[i].ShowHint:=True;
  end
  else
   if VanAdat then begin
    FGombok[i].Enabled:=True;
    FGombok[i].ShowHint:=True;
   end
 end;
 if VanToolBar then Spinner.Show else Spinner.Hide;
 Spinner.Enabled:=True;
end;

{Nincs tbb memria messagebox}

procedure TGraf.NincsTobbMemoria;
begin
 MessageDlg('Nincs tbb memria!',mtInformation,[mbOk],0);
end;

{Hibs fjl messagebox}

procedure TGraf.HibasFajl;
begin
 MessageDlg('A fjl hibs adatot tartalmaz!',mtInformation,[mbOk],0);
end;

{A komponenst hasznl alkalmazsnak szl zenet}

function TGraf.MentesKell: Boolean;
begin
 Result:=MentSzuks;
end;

{Pont adatait trol objektum konstruktora}

constructor TPont.Create(az: Word; x1,y1,x2,y2: Longint; j: Boolean);
begin
 inherited Create;
 azon:=az;
 x:=x1; y:=y1;
 sx:=x2; sy:=y2;
 jel:=j;
end;

{l adatait trol objektum konstruktora}

constructor TEl.Create(hossz: Longint; honnan,hova: Word; j: Boolean);
begin
 inherited Create;
 h:=hossz;
 p1:=honnan; p2:=hova;
 jel:=j;
end;

end.
