unit Csopbeo_Osszeall;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DBTables, Alap, Adatok, Nezeget;

type
  TfrmCsopbeo_Osszeall = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    lbCsoportok: TListBox;
    lbCsapatok: TListBox;
    lbJatekosok: TListBox;
    btnHozzaad: TButton;
    btnTorol: TButton;
    procedure lbCsoportokClick(Sender: TObject);
    procedure lbCsapatokClick(Sender: TObject);
    procedure btnHozzaadClick(Sender: TObject);
    procedure btnTorolClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure lbJatekosokClick(Sender: TObject);
  private
    { Private declarations }
    {Csoportbeoszts kell-e vagy csapatsszellts}
    Osszeallitas:boolean;
    {Mivel neveket ajnlunk ki a listbox-okban}
    CsoportKodok,CsapatKodok,JatekosKodok:TStringList;
  public
    { Public declarations }
    constructor Create(AOwner:TComponent; AOsszeallitas:boolean);
  end;

implementation

{$R *.DFM}

procedure TfrmCsopbeo_Osszeall.lbCsoportokClick(Sender: TObject);
begin
 if Osszeallitas then begin
  btnHozzaad.Enabled:=false;
  btnTorol.Enabled:=false;
 end else begin
  btnHozzaad.Enabled:=true;
  btnTorol.Enabled:=false;
 end;
 {Rllunk a megfelel csoport rekordra}
 dmAdatok.tblCsoport.FindKey([CsoportKodok[lbCsoportok.ItemIndex]]);
 {A listk trlse}
 CsapatKodok.Clear;
 lbCsapatok.Clear;
 if Osszeallitas then begin
  JatekosKodok.Clear;
  lbJatekosok.Clear;
 end;
 {A csoport csapatainak betltse}
 with dmAdatok.tblCsoportBeosztas do begin
  {A megfelel csoportbeoszts rekordok elrsre: Master-Detail}
  MasterSource:=dmAdatok.dtsCsoport;
  MasterFields:='Kd';
  IndexName:='Csoport';
  {A csapatnv elrsre: Master-Detail}
  dmAdatok.tblCsapat.MasterSource:=dmAdatok.dtsCsoportbeosztas;
  dmAdatok.tblCsapat.MasterFields:='Csapat';
  {Vgig a rekordokon}
  First;
  while not Eof do begin
   CsapatKodok.Add(FieldByName('Csapat').AsString);
   lbCsapatok.Items.Add(dmAdatok.tblCsapat.FieldByName('Nv').AsString);
   Next;
  end;
  {A Master-Detail kapcsolatok megszntetse}
  MasterSource:=nil;
  MasterFields:='';
  IndexName:='';
  dmAdatok.tblCsapat.MasterSource:=nil;
  dmAdatok.tblCsapat.MasterFields:='';
 end;
end;

procedure TfrmCsopbeo_Osszeall.lbCsapatokClick(Sender: TObject);
begin
 if Osszeallitas then begin
  if lbCsapatok.ItemIndex>-1 then begin
   btnHozzaad.Enabled:=true;
   btnTorol.Enabled:=false;
   {Rllunk a megfelel csoportbeoszts rekordra}
   dmAdatok.tblCsoportbeosztas.Locate('Csoport;Csapat',
    VarArrayOf([CsoportKodok[lbCsoportok.ItemIndex],
                CsapatKodok[lbCsapatok.ItemIndex]]),[]);
   {A csapat jtkosainak betltse}
   JatekosKodok.Clear;
   lbJatekosok.Clear;
   with dmAdatok.tblOsszeallitas do begin
    {A megfelel sszellts rekordok elrsre: Master-Detail}
    MasterSource:=dmAdatok.dtsCsoportbeosztas;
    MasterFields:='Kd';
    IndexName:='Hol';
    {A jtkosnv elrsre: Master-Detail}
    dmAdatok.tblJatekos.MasterSource:=dmAdatok.dtsOsszeallitas;
    dmAdatok.tblJatekos.MasterFields:='Jtkos';
    {Vgig a rekordokon}
    First;
    while not Eof do begin
     JatekosKodok.Add(FieldByName('Jtkos').AsString);
     lbJatekosok.Items.Add(dmAdatok.tblJatekos.FieldByName('Nv').AsString);
     Next;
    end;
    {A Master-Detail kapcsolatok megszntetse}
    MasterSource:=nil;
    MasterFields:='';
    IndexName:='';
    dmAdatok.tblJatekos.MasterSource:=nil;
    dmAdatok.tblJatekos.MasterFields:='';
   end;
  end else begin
   btnHozzaad.Enabled:=false;
   btnTorol.Enabled:=false;
  end;
 end else begin
  btnTorol.Enabled:=lbCsapatok.ItemIndex>-1;
 end;
end;

procedure TfrmCsopbeo_Osszeall.lbJatekosokClick(Sender: TObject);
begin
 btnTorol.Enabled:=lbCsapatok.ItemIndex>-1;
end;

procedure TfrmCsopbeo_Osszeall.btnHozzaadClick(Sender: TObject);
var frmNezeget:TfrmNezeget; qry:TQuery; s:string;
begin
 if Osszeallitas then begin
  {Csapatsszellts}
  qry:=TQuery.Create(Self);
  qry.DatabaseName:=AliasNev;
  {Az kezetes nevek megtrflhatnak, itt pl.}
  {az 'sszellts' kis -vel rva nem mkdik jl!}
  qry.sql.Add(
   'select jat.kd,jat.nv Nv,jat.kiegszts Kiegszts, '+
   '       szak.rvidts Szak '+
   'from jtkos jat,szak '+
   'where (jat.szak=szak.kd) and (jat.kd not in '+
   ' (select jat.kd from jtkos jat,sszellts ossz '+
   '  where jat.kd=ossz.jtkos and '+
   '   ossz.hol in '+
   '   (select csb.kd from csoportbeoszts csb '+
   '    where csb.csoport in '+
   '    (select cso.kd from csoport cso,vad ev,szezon sz '+
   '     where cso.vad=ev.kd and cso.szezon=sz.kd and '+
   '           ev.kd='+AktEvad+' and sz.kd='+AktSzezon+')))) '+
   'order by jat.nv');
  qry.Open;
  {A kdot, szak kdot ne lssuk}
  qry.FieldByName('Kd').Visible:=false;
  if qry.RecordCount=0 then begin
   ShowMessage('Nincs mr tbb felvehet jtkos!');
  end else begin
   {Vlaszthat jtkos rekordot}
   frmNezeget:=TfrmNezeget.Create(Self,qry,'Nv',
    'Jtkos vlaszts',idRVal);
   if frmNezeget.ShowModal=idRVal then begin
    {A listkban}
    s:=qry.FieldByName('Kd').AsString;
    JatekosKodok.Add(s);
    lbJatekosok.Items.Add(qry.FieldByName('Nv').AsString);
    {A tblban}
    with dmAdatok.tblOsszeallitas do begin
     Append;
     FieldByName('Jtkos').AsString:=s;
     {A csoportbeoszts tblban a megfelel rekordon llunk}
     FieldByName('Hol').AsString:=
      dmAdatok.tblCsoportbeosztas.FieldByName('Kd').AsString;
     Post;
    end;
   end;
   frmNezeget.Free;
  end;
  qry.Free;
 end else begin
  {Csoportbeoszts}
  qry:=TQuery.Create(Self);
  qry.DatabaseName:=AliasNev;
  qry.sql.Add(
   'select * from csapat csa '+
   'where csa.kd not in '+
   ' (select csa.kd from csapat csa,csoportbeoszts csb '+
   '  where csa.kd=csb.csapat and '+
   '   csb.csoport in '+
   '   (select cso.kd from csoport cso,vad ev,szezon sz '+
   '    where cso.vad=ev.kd and cso.szezon=sz.kd and '+
   '          ev.kd='+AktEvad+' and sz.kd='+AktSzezon+')) '+
   'order by csa.nv');
  qry.Open;
  {A kdot ne lssuk}
  qry.FieldByName('Kd').Visible:=false;
  if qry.RecordCount=0 then begin
   ShowMessage('Nincs mr tbb felvehet csapat!');
  end else begin
   {Vlaszthat csapat rekordot}
   frmNezeget:=TfrmNezeget.Create(Self,qry,'Nv',
    'Csapat vlaszts',idRVal);
   if frmNezeget.ShowModal=idRVal then begin
    {A listkban}
    s:=qry.FieldByName('Kd').AsString;
    CsapatKodok.Add(s);
    lbCsapatok.Items.Add(qry.FieldByName('Nv').AsString);
    {A tblban}
    with dmAdatok.tblCsoportBeosztas do begin
     Append;
     FieldByName('Csoport').AsString:=CsoportKodok[lbCsoportok.ItemIndex];
     FieldByName('Csapat').AsString:=s;
     Post;
    end;
   end;
   frmNezeget.Free;
  end;
  qry.Free;
 end;
end;

procedure TfrmCsopbeo_Osszeall.btnTorolClick(Sender: TObject);
var ok,VanMerk:boolean; qry:TQuery;
begin
 if Osszeallitas then begin
  {A tblban}
  with dmAdatok.tblOsszeallitas do begin
   {Rllunk a megfelel sszellts rekordra}
   Locate('Jtkos;Hol',
    VarArrayOf([JatekosKodok[lbJatekosok.ItemIndex],
     dmAdatok.tblCsoportbeosztas.FieldByName('Kd').AsString]),[]);
   try
    Delete;
   except
    ShowMessage('A jtkos nem trlhet!'+#13+
     '(Ms is hasznlja az sszellts tblt)');
   end;
  end;
  {A listkban}
  JatekosKodok.Delete(lbJatekosok.ItemIndex);
  lbJatekosok.Items.Delete(lbJatekosok.ItemIndex);
  btnTorol.Enabled:=false;
 end else begin
  {A tblban}
  ok:=true;
  {Van-e mr a csapatnak meccse}
  with dmAdatok.tblMerkozes do begin
   if Locate('Csoport;Hazaicsapat',
              VarArrayOf([CsoportKodok[lbCsoportok.ItemIndex],
                          CsapatKodok[lbCsapatok.ItemIndex]]),[]) or
      Locate('Csoport;Vendgcsapat',
              VarArrayOf([CsoportKodok[lbCsoportok.ItemIndex],
                          CsapatKodok[lbCsapatok.ItemIndex]]),[]) then begin
    ShowMessage('A csapat nem trlhet! (Van mr mrkzse)');
    ok:=false;
   end;
  end;
  if ok then begin
   with dmAdatok.tblCsoportBeosztas do begin
    {Rllunk a megfelel csoportbeoszts rekordra}
    Locate('Csoport;Csapat',
           VarArrayOf([CsoportKodok[lbCsoportok.ItemIndex],
                       CsapatKodok[lbCsapatok.ItemIndex]]),[]);
    try
     Delete;
    except
     ShowMessage('A csapat nem trlhet! (sszelltsban szerepel)');
     ok:=false;
    end;
   end;
  end;
  {A listkban}
  if ok then begin
   CsapatKodok.Delete(lbCsapatok.ItemIndex);
   lbCsapatok.Items.Delete(lbCsapatok.ItemIndex);
   btnTorol.Enabled:=false;
  end;
 end;
end;

constructor TfrmCsopbeo_Osszeall.Create(AOwner:TComponent; AOsszeallitas:boolean);
{Ennyi pixel szabad helyet hagyunk a mdost gombok mellett jobbrl}
const Szel=24;
begin
 inherited Create(Owner);
 Osszeallitas:=AOsszeallitas;
 CsoportKodok:=TStringList.Create;
 CsapatKodok:=TStringList.Create;
 if Osszeallitas then begin
  JatekosKodok:=TStringList.Create;
  Caption:='Csapatsszellts';
 end else begin
  Caption:='Csoportbeoszts';
  {A jtkos rsz ne ltszdjon, a form legyen keskenyebb}
  Label3.Visible:=false;
  lbJatekosok.Visible:=false;
  btnHozzaad.Left:=lbJatekosok.Left;
  btnTorol.Left:=lbJatekosok.Left;
  Width:=btnHozzaad.Left+btnHozzaad.Width+Szel;
 end;
 {Csoportok betltse}
 with dmAdatok.tblCsoport do begin
  {A tblCsoport AktEvad s AktSzezon szerint szrt}
  First;
  while not Eof do begin
   CsoportKodok.Add(FieldByName('Kd').AsString);
   lbCsoportok.Items.Add(FieldByName('Nv').AsString);
   Next;
  end;
 end;
 {Az els csoport automatikus kivlasztsa}
 lbCsoportok.ItemIndex:=0;
 lbCsoportokClick(nil);
end;

procedure TfrmCsopbeo_Osszeall.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
 CsoportKodok.Free;
 CsapatKodok.Free;
 if Osszeallitas then JatekosKodok.Free;
 Action:=caFree;
end;

end.


