unit Evad;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DBCtrls, DBTables, Grids, DBGrids, Alap, Adatok, Nezeget;

type
  TfrmEvad = class(TForm)
    Label1: TLabel;
    ComboBox1: TComboBox;
    Edit1: TEdit;
    btnPontozas: TButton;
    btnRendben: TButton;
    btnMegsem: TButton;
    Label2: TLabel;
    procedure btnRendbenClick(Sender: TObject);
    procedure btnMegsemClick(Sender: TObject);
    procedure btnPontozasClick(Sender: TObject);
  private
    { Private declarations }
    Funkcio:TMuvelet;
    {Az aktulisan kivlasztott pontozs kdja}
    PontKod:string;
  public
    { Public declarations }
    constructor Create(AOwner:TComponent; AFunkcio:TMuvelet);
  end;


implementation

{$R *.DFM}

procedure TfrmEvad.btnRendbenClick(Sender: TObject);
var s:integer; van,kilep:boolean;
begin
 case Funkcio of
  idUj,idMod:begin
   kilep:=false;
   {Adatellenrzs}
   if Edit1.Text='' then
    ShowMessage('Hinyos/hinyz adatok!')
   else begin
    {Van-e mr ilyen v}
    dmAdatok.tblEvad.IndexName:='vszerint';
    if Funkcio=idUj then begin
     van:=dmAdatok.tblEvad.FindKey([ComboBox1.Text])
    end else begin
     s:=dmAdatok.tblEvad.RecNo;
     van:=dmAdatok.tblEvad.FindKey([ComboBox1.Text]) and
          (s<>dmAdatok.tblEvad.RecNo);
     dmAdatok.tblEvad.RecNo:=s;
    end;
    dmAdatok.tblEvad.IndexName:='';
    if van then
     ShowMessage('Van mr ilyen v vad!')
    else begin
     {Helyesek az adatok}
     if Funkcio=idUj then
      dmAdatok.tblEvad.Append
     else
      dmAdatok.tblEvad.Edit;
     dmAdatok.tblEvad.FieldByName('v').AsString:=
      ComboBox1.Items[ComboBox1.ItemIndex];
     dmAdatok.tblEvad.FieldByName('Pontozs').AsString:=PontKod;
     dmAdatok.tblEvad.Post;
     kilep:=true;
    end;
   end;
  end;
  idTor:begin
   kilep:=true;
   try
    dmAdatok.tblEvad.Delete;
   except
    ShowMessage('A rekord nem trlhet! (Van ilyen vad csoport)');
    kilep:=false;
   end;
  end;
 end;
 if kilep then
  ModalResult:=mrOk;
end;

procedure TfrmEvad.btnPontozasClick(Sender: TObject);
var frmNezeget:TfrmNezeget;
begin
 if PontKod='' then
  {Ilyenkor az els pontozs rekordra llunk}
  dmAdatok.tblPontozas.First
 else
  {Rllunk a megfelel pontozs rekordra}
  dmAdatok.tblPontozas.FindKey([PontKod]);
 case Funkcio of
  idUj,idMod:begin
   {Vlaszthat pontozs rekordot}
   frmNezeget:=TfrmNezeget.Create(Self,dmAdatok.tblPontozas,'',
    'Pontozs vlaszts',idRVal);
   if frmNezeget.ShowModal=idRVal then begin
    PontKod:=dmAdatok.tblPontozas.FieldByName('Kd').AsString;
    Edit1.Text:=dmAdatok.tblPontozas.FieldByName('Nv').AsString;
   end;
  end;
  idTor:begin
   {Csak a trlend rekordhoz tartoz pontozs rekordot lssuk}
   dmAdatok.tblPontozas.Filter:='[Kd]='+
    dmAdatok.tblPontozas.FieldByName('Kd').AsString;
   dmAdatok.tblPontozas.Filtered:=true;
   frmNezeget:=TfrmNezeget.Create(Self,dmAdatok.tblPontozas,'',
    'A kapcsold pontozs rekord',idRNez);
   frmNezeget.ShowModal;
   dmAdatok.tblPontozas.Filtered:=false;
  end;
 end;
 frmNezeget.Free;
end;

procedure TfrmEvad.btnMegsemClick(Sender: TObject);
begin
 ModalResult:=mrCancel;
end;

constructor TfrmEvad.Create(AOwner:TComponent; AFunkcio:TMuvelet);
var i:integer; AktEv,UtEv,Ho,Nap:word; s:string;
begin
 inherited Create(Owner);
 Funkcio:=AFunkcio;
 Caption:=MuveletNev[Funkcio];
 {Az vek kiajnlshoz}
 DecodeDate(Date,AktEv,Ho,Nap);
 if AktEv>EvIg then UtEv:=AktEv else UtEv:=EvIg;
 for i:=EvTol to UtEv do
  ComboBox1.Items.Add(IntToStr(i));
 case Funkcio of
  idUj:begin
   {j vadnl az aktulis vet ajnljuk ki}
   ComboBox1.ItemIndex:=ComboBox1.Items.IndexOf(IntToStr(AktEv));
   Edit1.Text:=''; PontKod:='';
  end;
  idMod,idTor:begin
   s:=dmAdatok.tblEvad.FieldByName('v').AsString;
   ComboBox1.ItemIndex:=ComboBox1.Items.IndexOf(s);
   PontKod:=dmAdatok.tblEvad.FieldByName('Pontozs').AsString;
   {A megfelel adatot a vezrlbe}
   dmAdatok.tblPontozas.FindKey([PontKod]);
   Edit1.Text:=dmAdatok.tblPontozas.FieldByName('Nv').AsString;
   if Funkcio=idTor then begin
    ComboBox1.Enabled:=false;
   end;
  end;
 end;
end;

end.
