unit Jatekos;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Alap, Adatok, Nezeget;

type
  TfrmJatekos = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    btnSzak: TButton;
    btnRendben: TButton;
    btnMegsem: TButton;
    Edit3: TEdit;
    procedure btnRendbenClick(Sender: TObject);
    procedure btnMegsemClick(Sender: TObject);
    procedure btnSzakClick(Sender: TObject);
  private
    { Private declarations }
    Funkcio:TMuvelet;
    {Az aktulisan kivlasztott szak kdja}
    SzakKod:string;
  public
    { Public declarations }
    constructor Create(AOwner:TComponent; AFunkcio:TMuvelet);
  end;


implementation

{$R *.DFM}

procedure TfrmJatekos.btnRendbenClick(Sender: TObject);
var s:integer; van,kilep:boolean;
begin
 case Funkcio of
  idUj,idMod:begin
   kilep:=false;
   {Adatellenrzs}
   Edit1.Text:=Trim(Edit1.Text);
   Edit2.Text:=Trim(Edit2.Text);
   if (Edit1.Text='') or (Edit3.Text='') then
    ShowMessage('Hinyos/hinyz adatok!')
   else begin
    s:=dmAdatok.tblJatekos.FieldByName('Nv').Size;
    if length(Edit1.Text)>s then
     ShowMessage('A Nv mez maximum '+IntToStr(s)+' karakterbl llhat!')
    else begin
     s:=dmAdatok.tblJatekos.FieldByName('Kiegszts').Size;
     if length(Edit2.Text)>s then
      ShowMessage('A Kiegszts mez maximum '+IntToStr(s)+' karakterbl llhat!')
     else begin
      {Van-e mr ilyen (nv+kiegszts) jtkos}
      dmAdatok.tblJatekos.IndexName:='NvKiegszts';
      if Funkcio=idUj then begin
       van:=dmAdatok.tblJatekos.FindKey([Edit1.Text,Edit2.Text])
      end else begin
       s:=dmAdatok.tblJatekos.RecNo;
       van:=dmAdatok.tblJatekos.FindKey([Edit1.Text,Edit2.Text]) and
            (s<>dmAdatok.tblJatekos.RecNo);
       dmAdatok.tblJatekos.RecNo:=s;
      end;
      dmAdatok.tblJatekos.IndexName:='';
      if van then
       ShowMessage('Van mr ilyen (Nv+Kiegszts) jtkos!')
      else begin
       {Helyesek az adatok}
       if Funkcio=idUj then
        dmAdatok.tblJatekos.Append
       else
        dmAdatok.tblJatekos.Edit;
       dmAdatok.tblJatekos.FieldByName('Nv').AsString:=Edit1.Text;
       dmAdatok.tblJatekos.FieldByName('Kiegszts').AsString:=Edit2.Text;
       dmAdatok.tblJatekos.FieldByName('Szak').AsString:=SzakKod;
       dmAdatok.tblJatekos.Post;
       kilep:=true;
      end;
     end;
    end;
   end;
  end;
  idTor:begin
   kilep:=true;
   try
    dmAdatok.tblJatekos.Delete;
   except
    ShowMessage('A rekord nem trlhet! (Szerepel valamelyik csapatban)');
    kilep:=false;
   end;
  end;
 end;
 if kilep then
  ModalResult:=mrOk;
end;

procedure TfrmJatekos.btnSzakClick(Sender: TObject);
var frmNezeget:TfrmNezeget;
begin
 if SzakKod='' then
  {Az els szak rekordra llunk}
  dmAdatok.tblSzak.First
 else
  {Rllunk a megfelel szak rekordra}
  dmAdatok.tblSzak.FindKey([SzakKod]);
 case Funkcio of
  idUj,idMod:begin
   {Vlaszthat szak rekordot}
   dmAdatok.tblSzak.IndexName:='Nvszerint';
   frmNezeget:=TfrmNezeget.Create(Self,dmAdatok.tblSzak,'Nv',
    'Szak vlaszts',idRVal);
   if frmNezeget.ShowModal=idRVal then begin
    SzakKod:=dmAdatok.tblSzak.FieldByName('Kd').AsString;
    Edit3.Text:=dmAdatok.tblSzak.FieldByName('Rvidts').AsString;
   end;
   dmAdatok.tblSzak.IndexName:='';
  end;
  idTor:begin
   {Csak a trlend rekordhoz tartoz szak rekordot lssuk}
   dmAdatok.tblSzak.Filter:='[Kd]='+
    dmAdatok.tblSzak.FieldByName('Kd').AsString;
   dmAdatok.tblSzak.Filtered:=true;
   frmNezeget:=TfrmNezeget.Create(Self,dmAdatok.tblSzak,'',
    'A kapcsold szak rekord',idRNez);
   frmNezeget.ShowModal;
   dmAdatok.tblSzak.Filtered:=false;
  end;
 end;
 frmNezeget.Free;
end;

procedure TfrmJatekos.btnMegsemClick(Sender: TObject);
begin
 ModalResult:=mrCancel;
end;

constructor TfrmJatekos.Create(AOwner:TComponent; AFunkcio:TMuvelet);
begin
 inherited Create(Owner);
 Funkcio:=AFunkcio;
 Caption:=MuveletNev[Funkcio];
 case Funkcio of
  idUj:begin
   Edit1.Text:=''; Edit2.Text:=''; Edit3.Text:=''; SzakKod:='';
  end;
  idMod,idTor:begin
   Edit1.Text:=dmAdatok.tblJatekos.FieldByName('Nv').AsString;
   Edit2.Text:=dmAdatok.tblJatekos.FieldByName('Kiegszts').AsString;
   SzakKod:=dmAdatok.tblJatekos.FieldByName('Szak').AsString;
   {A megfelel adatot a vezrlbe}
   dmAdatok.tblSzak.FindKey([SzakKod]);
   Edit3.Text:=dmAdatok.tblSzak.FieldByName('Rvidts').AsString;
   if Funkcio=idTor then begin
    Edit1.Enabled:=false;
    Edit2.Enabled:=false;
   end;
  end;
 end;
end;

end.
