unit Merkozes;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, DBTables, Alap, Adatok, Nezeget;

type
  TfrmMerkozes = class(TForm)
    Label1: TLabel;
    lbCsoportok: TListBox;
    Edit1: TEdit;
    Edit2: TEdit;
    cbHgol: TComboBox;
    cbVgol: TComboBox;
    btnMerkozesek: TButton;
    btnHazai: TButton;
    btnVendeg: TButton;
    btnRendben: TButton;
    btnMegsem: TButton;
    procedure lbCsoportokClick(Sender: TObject);
    procedure btnMerkozesekClick(Sender: TObject);
    procedure btnHazaiClick(Sender: TObject);
    procedure btnVendegClick(Sender: TObject);
    procedure btnRendbenClick(Sender: TObject);
    procedure btnMegsemClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    {Mivel neveket ajnlunk ki a listbox-okban}
    CsoportKodok:TStringList;
    {Az aktulis karbantart funkci}
    Funkcio:integer;
    {Az j mrkzs hazai s vendg csapatnak kdjai}
    HazaiCsapatKod,VendegCsapatKod:string;
    {Egy rekord karbantartsa eltti tevkenysgei}
    procedure Kezd;
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}

procedure TfrmMerkozes.Kezd;
begin
 {Vezrlk alaphelyzetbe}
 Edit1.Text:=''; Edit2.Text:='';
 cbHgol.ItemIndex:=0; cbVgol.ItemIndex:=0;
 btnHazai.Enabled:=false;
 btnVendeg.Enabled:=false;
 cbHgol.Enabled:=false;
 cbVgol.Enabled:=false;
 {Az aktulis funkci}
 Funkcio:=idMerkVal;
 btnMerkozesek.Enabled:=true;
 Caption:='Eredmnyek '+MuveletNev[Funkcio];
end;

procedure TfrmMerkozes.lbCsoportokClick(Sender: TObject);
var frmNezeget:TfrmNezeget;
begin
 if lbCsoportok.ItemIndex>-1 then
  Kezd;
end;

procedure TfrmMerkozes.btnMerkozesekClick(Sender: TObject);
var frmNezeget:TfrmNezeget; qry:TQuery; s:string;
begin
 {A csoport mrkzseinek lekrdezse}
 qry:=TQuery.Create(Self);
 qry.DatabaseName:=AliasNev;
 qry.sql.Add(
  'select m.hazaicsapat, cs1.nv Hazai, '+
  '       m.vendgcsapat, cs2.nv Vendg, '+
  '       m.hazaigl H_gl, m.vendggl V_gl '+
  'from mrkzs m, csapat cs1, csapat cs2 '+
  'where m.hazaicsapat=cs1.kd and m.vendgcsapat=cs2.kd '+
  '      and m.csoport='+CsoportKodok[lbCsoportok.ItemIndex]+' '+
  'order by cs1.nv, cs2.nv');
 qry.Open;
 {A kdokat ne lssuk}
 qry.FieldByName('hazaicsapat').Visible:=false;
 qry.FieldByName('vendgcsapat').Visible:=false;
 frmNezeget:=TfrmNezeget.Create(Self,qry,'Hazai',
  'Mrkzsek',idMVal);
 Funkcio:=frmNezeget.ShowModal;
 if Funkcio in [idUj,idMod,idTor] then begin
  Caption:='Mrkzsek '+MuveletNev[Funkcio];
  btnMerkozesek.Enabled:=false;
  btnHazai.Enabled:=Funkcio=idUj;
  {Vendgcsapatot csak a hazai kivlasztsa utn lehet}
  btnVendeg.Enabled:=false;
  if Funkcio in [idMod,idTor] then begin
   cbHgol.Enabled:=Funkcio=idMod;
   cbVgol.Enabled:=Funkcio=idMod;
   {A kivlasztott mrkzs megjegyzse}
   HazaiCsapatKod:=qry.FieldByName('hazaicsapat').AsString;
   VendegCsapatKod:=qry.FieldByName('vendgcsapat').AsString;
   {Megjelentse}
   Edit1.Text:=qry.FieldByName('Hazai').AsString;
   Edit2.Text:=qry.FieldByName('Vendg').AsString;
   s:=qry.FieldByName('H_Gl').AsString;
   cbHgol.ItemIndex:=cbHgol.Items.IndexOf(s);
   s:=qry.FieldByName('V_Gl').AsString;
   cbVgol.ItemIndex:=cbVgol.Items.IndexOf(s);
  end;
 end else
  Funkcio:=idMerkVal;
 frmNezeget.Free;
 qry.Free;
end;

procedure TfrmMerkozes.btnHazaiClick(Sender: TObject);
var frmNezeget:TfrmNezeget; qry:TQuery;
begin
 {A hazai csapat brki lehet a csoportban}
 qry:=TQuery.Create(Self);
 qry.DatabaseName:=AliasNev;
 qry.sql.Add(
  'select * from csapat csa '+
  'where csa.kd in '+
  ' (select csa.kd from csapat csa,csoportbeoszts csb '+
  '  where csa.kd=csb.csapat and '+
  '   csb.csoport='+CsoportKodok[lbCsoportok.ItemIndex]+')'+
  'order by csa.nv');
 qry.Open;
 {A kdot ne lssuk}
 qry.FieldByName('Kd').Visible:=false;
 if qry.RecordCount=0 then begin
  ShowMessage('Nincs a csoportban csapat!')
 end else begin
  {Vlaszthat csapat rekordot}
  frmNezeget:=TfrmNezeget.Create(Self,qry,'Nv',
   'Hazai csapat vlaszts',idRVal);
  if frmNezeget.ShowModal=idRVal then begin
   HazaiCsapatKod:=qry.FieldByName('Kd').AsString;
   Edit1.Text:=qry.FieldByName('Nv').AsString;
   btnHazai.Enabled:=false;
   btnVendeg.Enabled:=true;
  end;
  frmNezeget.Free;
 end;
 qry.Free;
end;

procedure TfrmMerkozes.btnVendegClick(Sender: TObject);
var frmNezeget:TfrmNezeget; qry:TQuery;
begin
 {A vendg csapat csak olyan lehet, akivel mg nem jtszott}
 {az elzleg hazai csapatnak kivlasztott csapat}
 qry:=TQuery.Create(Self);
 qry.DatabaseName:=AliasNev;
 qry.sql.Add(
  'select * from csapat csa '+
  'where csa.kd<>'+HazaiCsapatKod+
  ' and csa.kd not in '+
  '     (select me.vendgcsapat from mrkzs me '+
  '      where me.hazaicsapat='+HazaiCsapatKod+' and '+
  '       me.csoport='+CsoportKodok[lbCsoportok.ItemIndex]+')'+
  ' and csa.kd not in '+
  '     (select me.hazaicsapat from mrkzs me '+
  '      where me.vendgcsapat='+HazaiCsapatKod+' and '+
  '       me.csoport='+CsoportKodok[lbCsoportok.ItemIndex]+')'+
  ' and csa.kd in '+
  '     (select csa.kd from csapat csa,csoportbeoszts csb '+
  '      where csa.kd=csb.csapat and '+
  '       csb.csoport='+CsoportKodok[lbCsoportok.ItemIndex]+')'+
  'order by csa.nv');
 qry.Open;
 {A kdot ne lssuk}
 qry.FieldByName('Kd').Visible:=false;
 if qry.RecordCount=0 then begin
  ShowMessage('Nincs (vlaszthat) vendg csapat!'+#13+
   '(Mr minden meccst lejtszotta a kivlasztott hazai csapat)');
 end else begin
  {Vlaszthat csapat rekordot}
  frmNezeget:=TfrmNezeget.Create(Self,qry,'Nv',
   'Hazai csapat vlaszts',idRVal);
  if frmNezeget.ShowModal=idRVal then begin
   VendegCsapatKod:=qry.FieldByName('Kd').AsString;
   Edit2.Text:=qry.FieldByName('Nv').AsString;
   btnVendeg.Enabled:=false;
   cbHgol.Enabled:=true;
   cbVgol.Enabled:=true;
  end;
  frmNezeget.Free;
 end;
 qry.Free;
end;

procedure TfrmMerkozes.btnRendbenClick(Sender: TObject);
var kilep:boolean;
begin
 case Funkcio of
  idUj,idMod:begin
   kilep:=false;
   {Adatellenrzs}
   if (Edit1.Text='') or (Edit2.Text='') then
    ShowMessage('Hinyos/hinyz adatok!')
   else begin
    {Helyesek az adatok}
    if Funkcio=idUj then begin
     dmAdatok.tblMerkozes.Append;
     dmAdatok.tblMerkozes.FieldByName('Csoport').AsString:=
      CsoportKodok[lbCsoportok.ItemIndex];
     dmAdatok.tblMerkozes.FieldByName('Hazaicsapat').AsString:=
      HazaiCsapatKod;
     dmAdatok.tblMerkozes.FieldByName('Vendgcsapat').AsString:=
      VendegCsapatKod;
    end else begin
     {Rllunk a megfelel mrkzs rekordra}
     dmAdatok.tblMerkozes.Locate('Csoport;Hazaicsapat;Vendgcsapat',
      VarArrayOf([CsoportKodok[lbCsoportok.ItemIndex],
                  HazaiCsapatKod,VendegCsapatKod]),[]);
     dmAdatok.tblMerkozes.Edit;
    end;
    dmAdatok.tblMerkozes.FieldByName('Hazaigl').AsString:=
     cbHgol.Items[cbHgol.ItemIndex];
    dmAdatok.tblMerkozes.FieldByName('Vendggl').AsString:=
     cbHgol.Items[cbVgol.ItemIndex];
    dmAdatok.tblMerkozes.Post;
    kilep:=true;
   end;
  end;
  idTor:begin
   kilep:=true;
   {Rllunk a megfelel mrkzs rekordra}
   dmAdatok.tblMerkozes.Locate('Csoport;Hazaicsapat;Vendgcsapat',
    VarArrayOf([CsoportKodok[lbCsoportok.ItemIndex],
                HazaiCsapatKod,VendegCsapatKod]),[]);
   try
    dmAdatok.tblMerkozes.Delete;
   except
    ShowMessage('A rekord nem trlhet!'+#13+
     '(Ms is hasznlja a Mrkzs tblt)');
    kilep:=false;
   end;
  end;
  idMerkVal:begin
   ShowMessage('Vlasszon mrkzst!');
   kilep:=false;
  end;
 end;
 if kilep then begin
  {Befejeztnk egy karbantartst}
  Kezd;
 end;
end;

procedure TfrmMerkozes.btnMegsemClick(Sender: TObject);
begin
 if Funkcio in [idUj,idMod,idTor] then
  Kezd
 else
  ModalResult:=mrCancel;
end;

procedure TfrmMerkozes.FormCreate(Sender: TObject);
var i:integer;
begin
 {Gl ComboBox-ok feltltse}
 for i:=0 to GolIg do begin
  cbHgol.Items.Add(IntToStr(i)); cbVgol.Items.Add(IntToStr(i));
 end;
 cbHgol.ItemIndex:=0; cbVgol.ItemIndex:=0;
 {Csoportok betltse}
 CsoportKodok:=TStringList.Create;
 with dmAdatok.tblCsoport do begin
  {A tblCsoport AktEvad s AktSzezon szerint szrt}
  First;
  while not Eof do begin
   CsoportKodok.Add(FieldByName('Kd').AsString);
   lbCsoportok.Items.Add(FieldByName('Nv').AsString);
   Next;
  end;
 end;
 {Az els csoport automatikus kivlasztsa}
 lbCsoportok.ItemIndex:=0;
 lbCsoportokClick(nil);
end;

procedure TfrmMerkozes.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
 CsoportKodok.Free;
 Action:=caFree;
end;

end.
