unit Nezeget;

{TDataSet sszes mezjnek megjelentse}
{s a megfelel mvelet (Muv) elvgzsnek biztostsa}
{Ha a keresmez nem res, akkor az a TDataSet egy ltez,}
{szveges mezjnek neve. Ezen mez tartalma alapjn}
{gyorsan kereshetnk rekordokat a TDataSet-ben, amelyet}
{clszer ppen ezen mez szerint rendezni/indexelni}
{A Memo s Blob mezk tartalma csak akkor jelenik meg,}
{ha a rcsban a megfelel (Memo, Blob) celln/mezn llunk}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, DBCtrls, Grids, DBGrids, StdCtrls, DBTables, DB, ComCtrls,
  Alap, Adatok;

type
  TfrmNezeget = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    DBNavigator1: TDBNavigator;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    DBGrid1: TDBGrid;
    DBMemo1: TDBMemo;
    DBImage1: TDBImage;
    btnUj: TButton;
    btnModosit: TButton;
    btnTorol: TButton;
    btnValaszt: TButton;
    procedure Edit1Change(Sender: TObject);
    procedure DBGrid1CellClick(Column: TColumn);
    procedure btnUjClick(Sender: TObject);
    procedure btnModositClick(Sender: TObject);
    procedure btnTorolClick(Sender: TObject);
    procedure DBGrid1ColEnter(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnValasztClick(Sender: TObject);
  private
    { Private declarations }
    ds:TDataSource;
    VanMemo,VanBlob:boolean;
    {Szveges mez, j ha az Adatok eszerint rendezettek}
    {Ha res, akkor nem lehet keresni}
    KeresoMezo:string;
  public
    { Public declarations }
    {A mdostgombok (ModGombok) s a vlasztgomb (ValGomb)}
    {egymst kizrjk}
    constructor Create(AOwner:TComponent; Adatok:TDataSet;
     AKeresoMezo,Fejlec:string; Muv:TMuvelet);
  end;

implementation

{$R *.DFM}

procedure TfrmNezeget.Edit1Change(Sender: TObject);
begin
 DbGrid1.DataSource.DataSet.Locate
  (KeresoMezo,Edit1.Text,[loCaseInsensitive,loPartialKey]);
end;

{A Memo ill. Blob mezk megjelentse/levtele}
procedure TfrmNezeget.DBGrid1CellClick(Column: TColumn);
begin
 if VanMemo then
  if DBGrid1.SelectedField.DataType=ftMemo then begin
   DBMemo1.DataSource:=DBGrid1.DataSource;
   DBMemo1.DataField:=DBGrid1.SelectedField.FieldName;
   DBMemo1.Visible:=true;
  end else begin
   DBMemo1.DataSource:=nil;
   DBMemo1.DataField:='';
   DBMemo1.Visible:=false;
  end;
 if VanBlob then
  if DBGrid1.SelectedField.DataType in
     [ftTypedBinary{,ftGraphic}] then begin
   DBImage1.DataSource:=DBGrid1.DataSource;
   DBImage1.DataField:=DBGrid1.SelectedField.FieldName;
   DBImage1.Visible:=true;
  end else begin
   DBImage1.DataSource:=nil;
   DBImage1.DataField:='';
   DBImage1.Visible:=false;
  end;
end;

{Ms cellra lpve frisstsk a Memo, Blob mezk megjelentst}
procedure TfrmNezeget.DBGrid1ColEnter(Sender: TObject);
begin
 DBGrid1CellClick(nil);
end;

procedure TfrmNezeget.btnUjClick(Sender: TObject);
begin
 ModalResult:=idUj;
end;

procedure TfrmNezeget.btnModositClick(Sender: TObject);
begin
 ModalResult:=idMod;
end;

procedure TfrmNezeget.btnTorolClick(Sender: TObject);
begin
 ModalResult:=idTor;
end;

procedure TfrmNezeget.btnValasztClick(Sender: TObject);
begin
 ModalResult:=idRVal;
end;

constructor TfrmNezeget.Create(AOwner:TComponent; Adatok:TDataSet;
 AKeresoMezo,Fejlec:string; Muv:TMuvelet);
var i:integer;
begin
 inherited Create(Owner);
 KeresoMezo:=AKeresoMezo;
 Caption:=Fejlec;
 if KeresoMezo='' then begin
  Label1.Visible:=false;
  Edit1.Visible:=false;
 end else begin
  Label1.Caption:=KeresoMezo;
 end;

 {Csak karbantarts esetn mdosthatunk}
 DBGrid1.ReadOnly:=Muv<>idKar;
 DBMemo1.ReadOnly:=Muv<>idKar;
 DBImage1.ReadOnly:=Muv<>idKar;

 {Egy rekord megtekintshez nem kell naviglni}
 DBNavigator1.Visible:=Muv<>idRNez;

 {Mdosts gombokat csak rekord mdosts vlasztsakor}
 btnUj.Visible:=Muv=idMVal;
 {Ha nincs rekord, akkor ne lehessen mdostani, trlni}
 btnModosit.Visible:=(Muv=idMVal) and (Adatok.RecordCount>0);
 btnTorol.Visible:=(Muv=idMVal) and (Adatok.RecordCount>0);

 {Vlaszt gombot csak rekord vlasztsnl}
 btnValaszt.Visible:=Muv=idRVal;
 {A Vlaszt gomb a Trl gomb helyn jelenjen meg}
 if btnValaszt.Visible then begin
  btnValaszt.Left:=btnTorol.Left;
  btnValaszt.Top:=btnTorol.Top;
 end;

 {A megjelentshez szksges adatforrs}
 ds:=TDataSource.Create(Self);
 ds.DataSet:=Adatok;

 DBGrid1.DataSource:=ds;
 DBNavigator1.DataSource:=ds;

 VanMemo:=false; VanBlob:=false;
 for i:=1 to Adatok.Fields.Count do begin
  if Adatok.Fields[i-1].DataType=ftMemo then VanMemo:=true;
  if Adatok.Fields[i-1].DataType in
     [ftTypedBinary{,ftGraphic}] then VanBlob:=true;
 end;

 {Csak akkor legyen Memo, Blob fl, ha kell}
 PageControl1.Pages[1].TabVisible:=VanMemo;
 PageControl1.Pages[2].TabVisible:=VanBlob;

 {A Memo, Blob mezk megjelentsnek igaztsa}
 DBGrid1CellClick(nil);
end;

procedure TfrmNezeget.FormDestroy(Sender: TObject);
begin
 ds.Free;
end;

end.


