unit Gyerek;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ComCtrls;

const
 Nevtelen='Nvtelen';

type
  TGyerekForm = class(TForm)
    RichEdit1: TRichEdit;
    MainMenu1: TMainMenu;
    Fajl: TMenuItem;
    Uj: TMenuItem;
    Megnyitas: TMenuItem;
    Bezaras: TMenuItem;
    MentesMaskent: TMenuItem;
    Mentes: TMenuItem;
    Nyomtatas: TMenuItem;
    Nyomtatobellitas: TMenuItem;
    N1: TMenuItem;
    Kilepes: TMenuItem;
    Szerkesztes: TMenuItem;
    Kivagas: TMenuItem;
    Masolas: TMenuItem;
    Beillesztes: TMenuItem;
    Torles: TMenuItem;
    MindentKijelol: TMenuItem;
    Formatum: TMenuItem;
    Betutipus: TMenuItem;
    N2: TMenuItem;
    Balra: TMenuItem;
    Kozepre: TMenuItem;
    Jobbra: TMenuItem;
    N3: TMenuItem;
    SzavakTordelese: TMenuItem;
    PrinterSetupDialog1: TPrinterSetupDialog;
    SaveDialog1: TSaveDialog;
    PopupMenu1: TPopupMenu;
    Kivagas1: TMenuItem;
    Masolas1: TMenuItem;
    Beillesztes1: TMenuItem;
    PrintDialog1: TPrintDialog;
    FontDialog1: TFontDialog;
    procedure UjClick(Sender: TObject);
    procedure BezarasClick(Sender: TObject);
    procedure KilepesClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure KivagasClick(Sender: TObject);
    procedure MasolasClick(Sender: TObject);
    procedure BeillesztesClick(Sender: TObject);
    procedure TorlesClick(Sender: TObject);
    procedure MindentKijelolClick(Sender: TObject);
    procedure SzerkesztesClick(Sender: TObject);
    procedure BetutipusClick(Sender: TObject);
    procedure Igazit(Sender:TObject);
    procedure FormatumClick(Sender: TObject);
    procedure SzavakTordeleseClick(Sender: TObject);
    procedure NyomtatobellitasClick(Sender: TObject);
    procedure MegnyitasClick(Sender: TObject);
    procedure MentesMaskentClick(Sender: TObject);
    procedure MentesClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure NyomtatasClick(Sender: TObject);
  private
    { Private declarations }
    {A fjl neve az elrsi ttal egytt}
    FajlUt:string;
  public
    { Public declarations }
    procedure Megnyit(Mit:string);
  end;

implementation

uses Clipbrd, Keret;

{$R *.DFM}

procedure TGyerekForm.UjClick(Sender: TObject);
begin
 KeretForm.UjClick(Sender);
end;

procedure TGyerekForm.KilepesClick(Sender: TObject);
begin
 KeretForm.KilepesClick(Sender);
end;

procedure TGyerekForm.KivagasClick(Sender: TObject);
begin
 RichEdit1.CutToClipboard;
end;

procedure TGyerekForm.MasolasClick(Sender: TObject);
begin
 RichEdit1.CopyToClipboard;
end;

procedure TGyerekForm.BeillesztesClick(Sender: TObject);
begin
 RichEdit1.PasteFromClipboard;
end;

procedure TGyerekForm.TorlesClick(Sender: TObject);
begin
 RichEdit1.ClearSelection;
end;

procedure TGyerekForm.MindentKijelolClick(Sender: TObject);
begin
 RichEdit1.SelectAll;
end;

procedure TGyerekForm.SzerkesztesClick(Sender: TObject);
var van:boolean;
begin
 van:=RichEdit1.SelLength>0;
 Kivagas.Enabled:=van;
 Kivagas1.Enabled:=van;
 Masolas.Enabled:=van;
 Masolas1.Enabled:=van;
 Torles.Enabled:=van;
 Beillesztes.Enabled:=Clipboard.HasFormat(CF_TEXT);
 Beillesztes1.Enabled:=Beillesztes.Enabled;
end;

procedure TGyerekForm.BetutipusClick(Sender: TObject);
begin
 if FontDialog1.Execute then
  RichEdit1.SelAttributes.Assign(FontDialog1.Font);
end;

procedure TGyerekForm.Igazit(Sender:TObject);
begin
 with TMenuItem(Sender) do begin
  Checked:=true;
  if Name='Balra' then
   RichEdit1.Paragraph.Alignment:=taLeftJustify
  else
  if Name='Jobbra' then
   RichEdit1.Paragraph.Alignment:=taRightJustify
  else
   RichEdit1.Paragraph.Alignment:=taCenter;
 end;
end;

procedure TGyerekForm.FormatumClick(Sender: TObject);
begin
 case RichEdit1.Paragraph.Alignment of
  taLeftJustify:Balra.Checked:=true;
  taRightJustify:Jobbra.Checked:=true;
  taCenter:Kozepre.Checked:=true;
 end;
end;

procedure TGyerekForm.SzavakTordeleseClick(Sender: TObject);
begin
 TMenuItem(Sender).Checked:=not TMenuItem(Sender).Checked;
 RichEdit1.WordWrap:=TMenuItem(Sender).Checked;
 if RichEdit1.WordWrap then
  RichEdit1.ScrollBars:=ssVertical
 else
  RichEdit1.ScrollBars:=ssBoth;
end;

procedure TGyerekForm.Megnyit(Mit:string);
begin
 FajlUt:=Mit;
 Caption:=ExtractFileName(Mit);
 RichEdit1.Lines.LoadFromFile(FajlUt);
 RichEdit1.Modified:=false;
end;

procedure TGyerekForm.MegnyitasClick(Sender: TObject);
begin
 KeretForm.MegnyitasClick(Sender);
end;

procedure TGyerekForm.MentesMaskentClick(Sender: TObject);
begin
 SaveDialog1.FileName:=FajlUt;
 if SaveDialog1.Execute then begin
  FajlUt:=SaveDialog1.FileName;
  Caption:=ExtractFileName(FajlUt);
  MentesClick(Sender);
 end;
end;

procedure TGyerekForm.MentesClick(Sender: TObject);
begin
 if FajlUt=Nevtelen then
  MentesMaskentClick(Sender)
 else begin
  RichEdit1.Lines.SaveToFile(FajlUt);
  RichEdit1.Modified:=false;
 end;
end;

procedure TGyerekForm.BezarasClick(Sender: TObject);
begin
 Close;
end;

procedure TGyerekForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 Action:=caFree;
end;

procedure TGyerekForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
 {A CanClose alaprtelmezsben true, ezrt csak a false-t lltjuk}
 if RichEdit1.Modified then
  case MessageDlg('A szveg ('+Caption+') mdosult!'+chr(13)+
        'Kvnja menteni?',mtConfirmation,
        [mbYes,mbNo,mbCancel],0) of
   mrYes:MentesClick(Sender);
   mrCancel:CanClose:=false;
  end;
end;

procedure TGyerekForm.NyomtatobellitasClick(Sender: TObject);
begin
 PrinterSetupDialog1.Execute;
end;

procedure TGyerekForm.NyomtatasClick(Sender: TObject);
begin
 if PrintDialog1.Execute then
  RichEdit1.Print(ExtractFileName(FajlUt));
end;

procedure TGyerekForm.FormCreate(Sender: TObject);
begin
 FajlUt:=Nevtelen;
end;

end.
